41a5a15455fa4dc1a7feefcdde6cca61c1124ae4
[clinton/abcde.git] / abcde
1 #!/bin/sh
2 # Copyright (c) 1998-2001 Robert Woodcock <rcw@debian.org>
3 # Copyright (c) 2003-2004 Jesus Climent <jesus.climent@hispalinux.es>
4 # This code is hereby licensed for public consumption under either the
5 # GNU GPL v2 or greater, or Larry Wall's Artistic license - your choice.
6 #
7 # You should have received a copy of the GNU General Public License
8 # along with this program; if not, write to the Free Software
9 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
10 #
11 # Copyright for this work is to expire January 1, 2010, after which it
12 # shall be public domain.
13
14 VERSION="2.3.0"
15
16 usage ()
17 {
18 echo "This is abcde v$VERSION."
19 echo "Usage: abcde [options] [tracks]"
20 echo "Options:"
21 echo "-1 Encode the whole CD in a single file"
22 echo "-a <action1[,action2]...>"
23 echo " Actions to perform (cddb,read,normalize,encode,tag,move,playlist,clean)"
24 #echo "-A Experimental actions (retag, transcode)"
25 echo "-b Batch mode: enable album normalization and nogap encoding"
26 echo "-c <file>"
27 echo " Specify a configuration file (overrides system and user config files)"
28 echo "-C <discid#>"
29 echo " Specify discid to resume from (only needed if you no longer have the cd)"
30 echo "-d <device>"
31 echo " Specify CDROM device to grab"
32 echo "-D Debugging mode (equivalent to sh -x abcde)"
33 echo "-e Erase encoded track information from status file"
34 echo "-h This help information"
35 #echo "-i Tag files while encoding, when possible (local only) -NWY-"
36 echo "-j <#> Number of encoder processes to run at once (localhost)"
37 echo "-k Keep the wav tracks for later use"
38 echo "-l Use low disk space algorithm"
39 echo "-L Use local CDDB storage directory"
40 echo "-n No lookup. Don't query CDDB, just create and use template"
41 echo "-N Noninteractive. Never prompt for anything"
42 echo "-m Modify playlist to include CRLF endings, to comply with some players"
43 echo "-M Create a CUE file"
44 echo "-o <type1[,type2]...>"
45 echo " Output file type(s) (ogg,mp3,flac,spx,mpc). Defaults to ogg"
46 echo "-p Pad track numbers with 0's (if less than 10 tracks)"
47 echo "-P Use UNIX pipes to read+encode without wav files"
48 echo "-r <host1[,host2]...>"
49 echo " Also encode on these remote hosts"
50 echo "-R Add replaygain values to the tag info (only for ogg,flac)"
51 echo "-S <#> Set the CD speed"
52 #echo "-t File types to preprocess (wav)"
53 #echo "-T Set postprocessing options"
54 echo "-t <#> Start the track numbering at a given number"
55 echo "-T <#> Same as -t but modifies tag numbering"
56 echo "-v Show version number and exit"
57 echo "-V Be a bit more verbose about what is happening behind the scenes"
58 echo "-x Eject CD after all tracks are read"
59 echo "-w <comment>"
60 echo " Add a comment to the CD tracks"
61 echo "-W <#> Contatenate CDs: -T #01 -w \"CD #\""
62 echo ""
63 echo "Tracks is a space-delimited list of tracks to grab."
64 echo "Ranges specified with hyphens are allowed."
65 #echo "Double hyphens are used to concatenate tracks"
66 }
67
68 # Funtions to replace the need of seq, which is too distribution dependant.
69 f_seq_row ()
70 {
71 i=$1
72 while [ $i -ne `expr $2 + 1` ]
73 do
74 echo $i
75 i=`expr $i + 1`
76 done
77 }
78
79 f_seq_line ()
80 {
81 i=$1
82 while [ $i -ne `expr $2 + 1` ]
83 do
84 printf $i" "
85 i=`expr $i + 1`
86 done
87 echo
88 }
89
90 # Functions to replace the need of awk {print $1} and {print $NF}
91 get_first()
92 {
93 if [ X"$1" = "X" ]; then
94 for first in `cat`; do
95 break
96 done
97 else
98 first=$1
99 fi
100 echo $first
101 }
102
103 get_last()
104 {
105 if [ X"$1" = "X" ]; then
106 for stdin in `cat`; do
107 last=$stdin
108 done
109 else
110 for last in $@ ; do :; done
111 fi
112 echo $last
113 }
114
115 # checkstatus [blurb]
116 # Returns "0" if the blurb was found, returns 1 if it wasn't
117 # Puts the blurb content, if available, on stdout.
118 # Otherwise, returns "".
119 checkstatus ()
120 {
121 # Take the last line in the status file if there's multiple matches
122 PATTERN="^$1(=.*)?$"
123 BLURB=$(egrep $PATTERN "$ABCDETEMPDIR/status" | tail -n 1)
124
125 if [ -z "$BLURB" ]; then
126 # No matches found
127 return 1
128 else
129 # Matches found
130 # See if there's a = in it
131 if [ "$(echo $BLURB | grep -c =)" != "0" ]; then
132 echo "$(echo $BLURB | cut -f2- -d=)"
133 fi
134 return 0
135 fi
136 }
137
138 # checkerrors [blurb]
139 # Returns "0" if the blurb was found (meaning there was an error),
140 # returns 1 if it wasn't (yes this is a little backwards).
141 # Does not print the blurb on stdout.
142 # Otherwise, returns "".
143 checkerrors ()
144 {
145 if [ -e "$ABCDETEMPDIR/errors" ]; then :; else
146 return 1
147 fi
148 # Take the last line in the status file if there's multiple matches
149 PATTERN="^$1(:.*)?$"
150 BLURB="$(egrep $PATTERN $ABCDETEMPDIR/errors | tail -n 1)"
151
152 if [ -z "$BLURB" ]; then
153 # negative, we did not have a negative...
154 return 1
155 else
156 # affirmative, we had a negative...
157 return 0
158 fi
159 }
160
161 # run_command [blurb] [command...]
162 # Runs a command, silently if necessary, and updates the status file
163 run_command ()
164 {
165 BLURB="$1"
166 shift
167 # See if this is supposed to be silent
168 if [ "$(checkstatus encode-output)" = "loud" ]; then
169 "$@" >&2
170 RETURN=$?
171 else
172 # Special case for SMP, since
173 # encoder output is never displayed, don't mute echos
174 if [ -z "$BLURB" -a "$MAXPROCS" != "1" ]; then
175 "$@" >&2
176 RETURN=$?
177 else
178 "$@" >/dev/null 2>&1
179 RETURN=$?
180 fi
181 fi
182 case "$1" in
183 normalize)
184 if [ "$RETURN" = "2" ]; then
185 # File was already normalized.
186 RETURN=0
187 fi
188 ;;
189 esac
190 if [ "$RETURN" != "0" ]; then
191 # Put an error in the errors file. For various reasons we
192 # can't capture a copy of the program's output but we can
193 # log what we attempted to execute and the error code
194 # returned by the program.
195 if [ "$BLURB" ]; then
196 TWEAK="$BLURB: "
197 fi
198 echo "${TWEAK}returned code $RETURN: $@" >> "$ABCDETEMPDIR/errors"
199 return $RETURN # Do not pass go, do not update the status file
200 fi
201 if [ "$BLURB" ]; then
202 echo $BLURB >> "$ABCDETEMPDIR/status"
203 fi
204 }
205
206 # relpath() and slash() are Copyright (c) 1999 Stuart Ballard and
207 # distributed under the terms of the GNU GPL v2 or later, at your option
208
209 # Function to determine if a word contains a slash.
210 slash ()
211 {
212 case "$1" in
213 */*) return 0;;
214 *) return 1;;
215 esac
216 }
217
218 # Function to give the relative path from one file to another.
219 # Usage: relpath fromfile tofile
220 # eg relpath music/Artist/Album.m3u music/Artist/Album/Song.mp3
221 # (the result would be Album/Song.mp3)
222 # Output is relative path to $2 from $1 on stdout
223
224 # This code has the following restrictions:
225 # Multiple ////s are not collapsed into single /s, with strange effects.
226 # Absolute paths and ../s are handled wrong in FR (but they work in TO)
227 # If FR is a directory it must have a trailing /
228
229 relpath ()
230 {
231 FR="$1"
232 TO="$2"
233
234 case "$TO" in
235 /*) ;; # No processing is needed for absolute paths
236 *)
237 # Loop through common prefixes, ignoring them.
238 while slash "$FR" && [ "$(echo "$FR" | cut -d/ -f1)" = "$(echo "$TO" | cut -d/ -f1)" ]
239 do
240 FR="$(echo "$FR" | cut -d/ -f2-)"
241 TO="$(echo "$TO" | cut -d/ -f2-)"
242 done
243 # Loop through directory portions left in FR, adding appropriate ../s.
244 while slash "$FR"
245 do
246 FR="$(echo "$FR" | cut -d/ -f2-)"
247 TO="../$TO"
248 done
249 ;;
250 esac
251
252 echo $TO
253 }
254
255 # This code splits the a Various Artist track name from one of the following
256 # forms:
257 #
258 # forward: Artist / Track
259 # forward-dash: Artist - Track
260 # reverse: Track / Artist
261 # reverse-dash: Track - Artist
262 # colon: Artist: Track
263 # trailing-paren: Artist (Track)
264 #
265 # variables used:
266 # VARIOUSARTISTS, VARIOUSARTISTSTYLE, TRACKNAME, TRACKARTIST
267 splitvarious ()
268 {
269 if [ "$VARIOUSARTISTS" = "y" ] && [ ! "$ONETRACK" = "y" ]; then
270 case "$VARIOUSARTISTSTYLE" in
271 forward)
272 DTITLEARTIST=$(echo "$TRACKNAME" | sed 's- / -~-g')
273 TRACKARTIST=$(echo "$DTITLEARTIST" | cut -f1 -d~)
274 TRACKNAME=$(echo "$DTITLEARTIST" | cut -f2 -d~)
275 ;;
276 forward-dash)
277 DTITLEARTIST=$(echo "$TRACKNAME" | sed 's, - ,~,g')
278 TRACKARTIST=$(echo "$DTITLEARTIST" | cut -f1 -d~)
279 TRACKNAME=$(echo "$DTITLEARTIST" | cut -f2 -d~)
280 ;;
281 reverse)
282 DTITLEARTIST=$(echo "$TRACKNAME" | sed 's- / -~-g')
283 TRACKARTIST=$(echo "$DTITLEARTIST" | cut -f2 -d~)
284 TRACKNAME=$(echo "$DTITLEARTIST" | cut -f1 -d~)
285 ;;
286 reverse-dash)
287 DTITLEARTIST=$(echo "$TRACKNAME" | sed 's, - ,~,g')
288 TRACKARTIST=$(echo "$DTITLEARTIST" | cut -f2 -d~)
289 TRACKNAME=$(echo "$DTITLEARTIST" | cut -f1 -d~)
290 ;;
291 colon)
292 DTITLEARTIST=$(echo "$TRACKNAME" | sed 's-: -~-g')
293 TRACKARTIST=$(echo "$DTITLEARTIST" | cut -f1 -d~)
294 TRACKNAME=$(echo "$DTITLEARTIST" | cut -f2 -d~)
295 ;;
296 trailing-paren)
297 DTITLEARTIST=$(echo "$TRACKNAME" | sed 's,^\(.*\) (\(.*\)),\1~\2,')
298 TRACKARTIST=$(echo "$DTITLEARTIST" | cut -f2 -d~)
299 TRACKNAME=$(echo "$DTITLEARTIST" | cut -f1 -d~)
300 ;;
301 esac
302 elif [ "$ONETRACK" = "y" ]; then
303 TRACKARTIST="Various"
304 else
305 TRACKARTIST="$DARTIST"
306 fi
307 }
308
309 do_getgenreid () {
310 local genre=$(echo "${@}" | tr '[A-Z]' '[a-z]')
311 local id=""
312 case ${genre} in
313 "blues") id=0 ;;
314 "classic rock") id=1 ;;
315 "country") id=2 ;;
316 "dance") id=3 ;;
317 "disco") id=4 ;;
318 "funk") id=5 ;;
319 "grunge") id=6 ;;
320 "hip-hop") id=7 ;;
321 "jazz") id=8 ;;
322 "metal") id=9 ;;
323 "new age") id=10 ;;
324 "oldies") id=11 ;;
325 "other") id=12 ;;
326 "pop") id=13 ;;
327 "r&b") id=14 ;;
328 "rap") id=15 ;;
329 "reggae") id=16 ;;
330 "rock") id=17 ;;
331 "techno") id=18 ;;
332 "industrial") id=19 ;;
333 "alternative") id=20 ;;
334 "ska") id=21 ;;
335 "death metal") id=22 ;;
336 "pranks") id=23 ;;
337 "soundtrack") id=24 ;;
338 "euro-techno") id=25 ;;
339 "ambient") id=26 ;;
340 "trip-hop") id=27 ;;
341 "vocal") id=28 ;;
342 "jazz+funk") id=29 ;;
343 "fusion") id=30 ;;
344 "trance") id=31 ;;
345 "classical") id=32 ;;
346 "instrumental") id=33 ;;
347 "acid") id=34 ;;
348 "house") id=35 ;;
349 "game") id=36 ;;
350 "sound clip") id=37 ;;
351 "gospel") id=38 ;;
352 "noise") id=39 ;;
353 "alt. rock") id=40 ;;
354 "bass") id=41 ;;
355 "soul") id=42 ;;
356 "punk") id=43 ;;
357 "space") id=44 ;;
358 "meditative") id=45 ;;
359 "instrum. pop") id=46 ;;
360 "instrum. rock") id=47 ;;
361 "ethnic") id=48 ;;
362 "gothic") id=49 ;;
363 "darkwave") id=50 ;;
364 "techno-indust.") id=51 ;;
365 "electronic") id=52 ;;
366 "pop-folk") id=53 ;;
367 "eurodance") id=54 ;;
368 "dream") id=55 ;;
369 "southern rock") id=56 ;;
370 "comedy") id=57 ;;
371 "cult") id=58 ;;
372 "gangsta") id=59 ;;
373 "top 40") id=60 ;;
374 "christian rap") id=61 ;;
375 "pop/funk") id=62 ;;
376 "jungle") id=63 ;;
377 "native american") id=64 ;;
378 "cabaret") id=65 ;;
379 "new wave") id=66 ;;
380 "psychadelic") id=67 ;;
381 "rave") id=68 ;;
382 "showtunes") id=69 ;;
383 "trailer") id=70 ;;
384 "lo-fi") id=71 ;;
385 "tribal") id=72 ;;
386 "acid punk") id=73 ;;
387 "acid jazz") id=74 ;;
388 "polka") id=75 ;;
389 "retro") id=76 ;;
390 "musical") id=77 ;;
391 "rock & roll") id=78 ;;
392 "hard rock") id=79 ;;
393 "folk") id=80 ;;
394 "folk/rock") id=81 ;;
395 "national folk") id=82 ;;
396 "swing") id=83 ;;
397 "fusion") id=84 ;;
398 "bebob") id=85 ;;
399 "latin") id=86 ;;
400 "revival") id=87 ;;
401 "celtic") id=88 ;;
402 "bluegrass") id=89 ;;
403 "avantgarde") id=90 ;;
404 "gothic rock") id=91 ;;
405 "progress. rock") id=92 ;;
406 "psychadel. rock") id=93 ;;
407 "symphonic rock") id=94 ;;
408 "slow rock") id=95 ;;
409 "big band") id=96 ;;
410 "chorus") id=97 ;;
411 "easy listening") id=98 ;;
412 "acoustic") id=99 ;;
413 "humour") id=100 ;;
414 "speech") id=101 ;;
415 "chanson") id=102 ;;
416 "opera") id=103 ;;
417 "chamber music") id=104 ;;
418 "sonata") id=105 ;;
419 "symphony") id=106 ;;
420 "booty bass") id=107 ;;
421 "primus") id=108 ;;
422 "porn groove") id=109 ;;
423 "satire") id=110 ;;
424 "slow jam") id=111 ;;
425 "club") id=112 ;;
426 "tango") id=113 ;;
427 "samba") id=114 ;;
428 "folklore") id=115 ;;
429 "ballad") id=116 ;;
430 "power ballad") id=117 ;;
431 "rhythmic soul") id=118 ;;
432 "freestyle") id=119 ;;
433 "duet") id=120 ;;
434 "punk rock") id=121 ;;
435 "drum solo") id=122 ;;
436 "a capella") id=123 ;;
437 "euro-house") id=124 ;;
438 "dance hall") id=125 ;;
439 "goa") id=126 ;;
440 "drum & bass") id=127 ;;
441 "club-house") id=128 ;;
442 "hardcore") id=129 ;;
443 "terror") id=130 ;;
444 "indie") id=131 ;;
445 "britpop") id=132 ;;
446 "negerpunk") id=133 ;;
447 "polsk punk") id=134 ;;
448 "beat") id=135 ;;
449 "christian gangsta rap") id=136 ;;
450 "heavy metal") id=137 ;;
451 "black metal") id=138 ;;
452 "crossover") id=139 ;;
453 "contemporary christian")id=140 ;;
454 "christian rock") id=141 ;;
455 "merengue") id=142 ;;
456 "salsa") id=143 ;;
457 "thrash metal") id=144 ;;
458 "anime") id=145 ;;
459 "jpop") id=146 ;;
460 "synthpop") id=147 ;;
461 *) return 1 ;;
462 esac
463 echo ${id}
464 return 0
465 }
466
467 # do_tag [tracknumber]
468 # id3 tags a filename
469 # variables used:
470 # TRACKS, TRACKNAME, TRACKARTIST, TAGGER, TAGGEROPTS, VORBISCOMMENT, METAFLAC,
471 # COMMENT, DALBUM, DARTIST, CDYEAR, CDGENRE (and temporarily) ID3TAGV
472 do_tag ()
473 {
474 COMMENTOUTPUT="$(eval echo ${COMMENT})"
475 run_command '' echo "Tagging track $1 of $TRACKS: $TRACKNAME..."
476 # If we want to start the tracks with a given number, we need to modify the
477 # TRACKNUM value before evaluation
478 if [ -n "$STARTTRACKNUMBER" -a -n "$STARTTRACKNUMBERTAG" ] ; then
479 # Get the trackpadding from the current track
480 CURRENTTRACKPADDING=$(echo -n $UTRACKNUM | wc -c)
481 TRACKNUM=$( printf %0.${CURRENTTRACKPADDING}d $(expr ${UTRACKNUM} + ${STARTTRACKNUMBER} - $FIRSTTRACK ))
482 fi
483 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
484 do
485 case "$OUTPUT" in
486 mp3)
487 # id3v2 v0.1.9 claims to have solved the -c bug, so we merge both id3 and id3v2
488 GENREID=$(do_getgenreid "${CDGENRE}")
489
490 # FIXME # track numbers in mp3 come with 1/10, so we cannot happily substitute them with $TRACKNUM
491 run_command tagtrack-$1 $TAGGER $TAGGEROPTS -c "$COMMENTOUTPUT" \
492 -A "$DALBUM" -a "$TRACKARTIST" -t "$TRACKNAME" -y "$CDYEAR" \
493 -g "$GENREID" -T "${TRACKNUM:-$1/$TRACKS}" \
494 "$ABCDETEMPDIR/track$1.$OUTPUT"
495 ;;
496 ogg)
497 case "$OGGENCODERSYNTAX" in
498 vorbize|oggenc)
499 # vorbiscomment can't do in-place modification, mv the file first
500 if [ -f "$ABCDETEMPDIR/track$1.$OUTPUT" -a ! -f "$ABCDETEMPDIR/track$1.uncommented.$OUTPUT" ]; then
501 mv "$ABCDETEMPDIR/track$1.$OUTPUT" "$ABCDETEMPDIR/track$1.uncommented.$OUTPUT"
502 fi
503 (
504 # These are from http://www.xiph.org/ogg/vorbis/doc/v-comment.html
505 echo ARTIST="$TRACKARTIST"
506 echo ALBUM="$DALBUM"
507 echo TITLE="$TRACKNAME"
508 if [ -n "$CDYEAR" ]; then
509 echo DATE="$CDYEAR"
510 fi
511 if [ -n "$CDGENRE" ]; then
512 echo GENRE="$CDGENRE"
513 fi
514 echo TRACKNUMBER=${TRACKNUM:-$1}
515 echo CDDB=$CDDBDISCID
516 if [ "$(eval echo ${COMMENT})" != "" ]; then
517 case "$COMMENTOUTPUT" in
518 *=*) echo "$COMMENTOUTPUT";;
519 *) echo COMMENT="$COMMENTOUTPUT";;
520 esac
521 fi
522 ) | run_command tagtrack-$1 $VORBISCOMMENT $VORBISCOMMENTOPTS -w \
523 "$ABCDETEMPDIR/track$1.uncommented.$OUTPUT" "$ABCDETEMPDIR/track$1.$OUTPUT"
524 # Doublecheck that the commented file was created successfully before wiping the original
525 if [ -f "$ABCDETEMPDIR/track$1.$OUTPUT" ]; then
526 rm -f "$ABCDETEMPDIR/track$1.uncommented.$OUTPUT"
527 else
528 mv "$ABCDETEMPDIR/track$1.uncommented.$OUTPUT" "$ABCDETEMPDIR/track$1.$OUTPUT"
529 fi
530 ;;
531 esac
532 ;;
533 flac)
534 ## FIXME ## [ "$FLACONOGG" = "y" ] && OUTPUT=ogg
535 (
536 echo ARTIST="$TRACKARTIST"
537 echo ALBUM="$DALBUM"
538 echo TITLE="$TRACKNAME"
539 if [ -n "$CDYEAR" ]; then
540 echo DATE="$CDYEAR"
541 fi
542 if [ -n "$CDGENRE" ]; then
543 echo GENRE="$CDGENRE"
544 fi
545 echo TRACKNUMBER=${TRACKNUM:-$1}
546 echo CDDB=$CDDBDISCID
547 if [ "$(eval echo ${COMMENT})" != "" ]; then
548 case "$COMMENTOUTPUT" in
549 *=*) echo "$COMMENTOUTPUT";;
550 *) echo COMMENT="$COMMENTOUTPUT";;
551 esac
552 fi
553 ) | run_command tagtrack-$1 $METAFLAC $METAFLACOPTS --import-tags-from=- "$ABCDETEMPDIR/track$1.$OUTPUT"
554 ;;
555 spx)
556 run_command tagtrack-$1 true
557 ;;
558 mpc)
559 run_command tagtrack-$1 true
560 ;;
561 esac
562 done
563 }
564
565 # do_batch_encode
566 # variables used:
567 # OUTPUTTYPE, {FOO}ENCODERSYNTAX, ENCNICE, ENCODER, ENCODEROPTS
568 do_batch_encode ()
569 {
570 # The commands here don't go through run_command because they're never supposed to be silenced
571 echo "Batch encoding tracks: $TRACKQUEUE"
572 OUTPUT=$(echo $OUTPUTTYPE | grep "mp3" )
573 case "$OUTPUT" in
574 mp3)
575 case "$MP3ENCODERSYNTAX" in
576 lame)
577 (
578 cd "$ABCDETEMPDIR"
579 TRACKFILES=
580 for UTRACKNUM in $TRACKQUEUE
581 do
582 TRACKFILES="$TRACKFILES track$UTRACKNUM.wav"
583 done
584 nice $ENCNICE $MP3ENCODER $MP3ENCODEROPTS --nogap $TRACKFILES
585 RETURN=$?
586 if [ "$RETURN" != "0" ]; then
587 echo "batch-encode: $ENCODER returned code $RETURN" >> errors
588 else
589 for UTRACKNUM in $TRACKQUEUE
590 do
591 echo encodetrack-$UTRACKNUM >> status
592 done
593 fi
594 )
595 ;;
596 esac
597 ;;
598 esac
599 # Other encoders fall through to normal encoding as the tracks
600 # have not been entered in the status file.
601 }
602
603 # do_encode [tracknumber] [hostname]
604 # If no hostname is specified, encode locally
605 # variables used:
606 # TRACKS, TRACKNAME, TRACKARTIST, DISTMP3, DISTMP3OPTS, {FOO}ENCODERSYNTAX, OUTPUTTYPE, ENCODEROPTS, DALBUM, DARTIST, ENCNICE, CDYEAR, CDGENRE, COMMENT
607 do_encode ()
608 {
609 if [ "$USEPIPES" = "y" ]; then
610 case "$OUTPUT" in
611 mp3)
612 TEMPARG="PIPE_$MP3ENCODERSYNTAX"
613 ;;
614 ogg)
615 TEMPARG="PIPE_$OGGENCODERSYNTAX"
616 ;;
617 flac)
618 TEMPARG="PIPE_$FLACENCODERSYNTAX"
619 ;;
620 spx)
621 TEMPARG="PIPE_$SPEEXENCODER"
622 ;;
623 mpc)
624 TEMPARG="PIPE_$MPPENCODER"
625 ;;
626 esac
627 IN=${!TEMPARG}
628 else
629 IN="$ABCDETEMPDIR/track$1.wav"
630 case "$OUTPUT" in
631 mp3)
632 case "$MP3ENCODERSYNTAX" in
633 # FIXME # check if mp3enc needs -if for pipes
634 mp3enc)
635 FILEARG="-if $IN"
636 ;;
637 *)
638 FILEARG=$IN
639 ;;
640 esac
641 ;;
642 *)
643 FILEARG=$IN
644 ;;
645 esac
646 fi
647 # We need IN to proceed, if we are not using pipes.
648 if [ -s "$IN" -o X"$USEPIPES" = "Xy" ] ; then
649 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
650 do
651 OUT="$ABCDETEMPDIR/track$1.$OUTPUT"
652 if [ X"$USEPIPES" = "Xy" ]; then
653 RUN_COMMAND=""
654 else
655 run_command '' echo "Encoding track $1 of $TRACKS: $TRACKNAME..."
656 RUN_COMMAND="run_command encodetrack-$OUTPUT-$1"
657 fi
658 case "$OUTPUT" in
659 mp3)
660 case "$2" in
661 %local*%)
662 case "$MP3ENCODERSYNTAX" in
663 lame|gogo) $RUN_COMMAND nice $ENCNICE $MP3ENCODER $MP3ENCODEROPTS "$IN" "$OUT" ;;
664 bladeenc) $RUN_COMMAND nice $ENCNICE $MP3ENCODER $MP3ENCODEROPTS -quit "$IN" ;;
665 l3enc|xingmp3enc) $RUN_COMMAND nice $ENCNICE $MP3ENCODER "$IN" "$OUT" $MP3ENCODEROPTS ;;
666 # FIXME # Relates to the previous FIXME since it might need the "-if" removed.
667 mp3enc) $RUN_COMMAND nice $ENCNICE $MP3ENCODER -if "$IN" -of "$OUT" $MP3ENCODEROPTS ;;
668 esac
669 ;;
670 *)
671 $RUN_COMMAND nice $DISTMP3NICE $DISTMP3 $DISTMP3OPTS "$2" "$IN" "$OUT" >/dev/null 2>&1
672 ;;
673 esac
674 ;;
675 ogg)
676 case "$2" in
677 %local*%)
678 case "$OGGENCODERSYNTAX" in
679 vorbize) $RUN_COMMAND nice $ENCNICE $OGGENCODER $OGGENCODEROPTS -w "$OUT" "$IN" ;;
680 oggenc) $RUN_COMMAND nice $ENCNICE $OGGENCODER $OGGENCODEROPTS -o "$OUT" "$IN" ;;
681 esac
682 ;;
683 *)
684 $RUN_COMMAND nice $DISTMP3NICE $DISTMP3 $DISTMP3OPTS "$2" "$IN" "$OUT" >/dev/null 2>&1
685 ;;
686 esac
687 ;;
688 flac)
689 case "$2" in
690 %local*%)
691 case "$FLACENCODERSYNTAX" in
692 flac) $RUN_COMMAND nice $ENCNICE $FLACENCODER $FLACENCODEROPTS -o "$OUT" "$IN" ;;
693 esac
694 ;;
695
696 *)
697 echo -n "DISTMP3:"
698 echo "$DISTMP3 $DISTMP3OPTS $2 $IN $OUT >/dev/null 2>&1"
699 $RUN_COMMAND nice $DISTMP3NICE $DISTMP3 $DISTMP3OPTS "$2" "$IN" "$OUT" > /dev/null 2>&1
700 ;;
701 esac
702 ;;
703 spx)
704 if [ "$(eval echo ${COMMENT})" != "" ]; then
705 case "$COMMENT" in
706 *=*) ;;
707 *) COMMENT="COMMENT=$COMMENT" ;;
708 esac
709 COMMENT="--comment \"$COMMENT\""
710 fi
711 # Quick hack to avoid tagging Ogg/Speex, since there is no other way to tag than inline tagging
712 if [ ! "$DOTAG" = "y" ]; then
713 $RUN_COMMAND nice $ENCNICE $SPEEXENCODER $SPEEXENCODEROPTS --author "$TRACKARTIST" --title "$TRACKNAME" "$COMMENT" "$IN" "$OUT"
714 else
715 $RUN_COMMAND nice $ENCNICE $SPEEXENCODER $SPEEXENCODEROPTS "$IN" "$OUT"
716 fi
717 ;;
718 mpc)
719 # MPP/MP+(Musepack) format (.mpc) is done locally, with inline
720 # tagging.
721 # I tried compiling the mppenc from corecodecs.org and got some
722 # errors, so I have not tried it myself.
723 ## FIXME ## Needs some cleanup to determine if an empty tag sent
724 ## FIXME ## to the encoder ends up empty.
725 $RUN_COMMAND nice $ENCNICE $MPPENCODER $MPPENCODEROPTS --artist "$TRACKARTIST" --album "$DALBUM" --title "$TRACKNAME" --track "$1" --genre "$CDGENRE" --year "$CDYEAR" --comment "$COMMENT" "$IN" "$OUT"
726 ;;
727 esac
728 done
729 # Only remove .wav if the encoding succeeded
730 if checkerrors "encodetrack-(.{3,4})-$1"; then
731 run_command encodetrack-$1 false
732 else
733 run_command encodetrack-$1 true
734 if [ ! "$KEEPWAVS" = "y" ] ; then
735 rm -f "$IN"
736 fi
737 fi
738 else
739 if [ "$(checkstatus encode-output)" = "loud" ]; then
740 echo "HEH! The file we were about to encode disappeared:"
741 echo ">> $IN"
742 fi
743 run_command encodetrack-$1 false
744 fi
745 }
746
747 # do_preprocess [tracknumber]
748 # variables used:
749 # TRACKS, TRACKNAME, TRACKARTIST, DISTMP3, DISTMP3OPTS, {FOO}ENCODERSYNTAX, OUTPUTTYPE, ENCODEROPTS, DALBUM, DARTIST, ENCNICE, CDYEAR, CDGENRE, COMMENT
750 #do_preprocess ()
751 #{
752 # IN="$ABCDETEMPDIR/track$1.wav"
753 # # We need IN to proceed.
754 # if [ -s "$IN" ] ; then
755 # for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
756 # do
757 # #OUT="$ABCDETEMPDIR/track$1.$OUTPUT"
758 # run_command '' echo "Pre-processing track $1 of $TRACKS..."
759 # case "$POSTPROCESSFORMAT" in
760 # all|wav*)
761 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $WAV_PRE $IF $OF ;;
762 # mp3)
763 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $MP3_PRE $IF $OF ;;
764 # ogg)
765 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $OGG_PRE $IF $OF ;;
766 # flac)
767 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $FLAC_PRE $IF $OF ;;
768 # spx)
769 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $SPX_PRE $IF $OF ;;
770 # esac
771 # done
772 # # Only remove .wav if the encoding succeeded
773 # if checkerrors "preprocess-(.{3,4})-$1"; then
774 # run_command preprocess-$1 false
775 # else
776 # run_command preprocess-$1 true
777 # fi
778 # else
779 # if [ "$(checkstatus encode-output)" = "loud" ]; then
780 # echo "HEH! The file we were about to pre-process disappeared:"
781 # echo ">> $IN"
782 # fi
783 # run_command preprocess-$1 false
784 # fi
785 #}
786
787
788 # do_postprocess [tracknumber]
789 # variables used:
790 # TRACKS, TRACKNAME, TRACKARTIST, DISTMP3, DISTMP3OPTS, {FOO}ENCODERSYNTAX, OUTPUTTYPE, ENCODEROPTS, DALBUM, DARTIST, ENCNICE, CDYEAR, CDGENRE, COMMENT
791 #do_postprocess ()
792 #{
793 # for POSTPROCESSFORMAT in $(echo $POSTPROCESSFORMATS | tr , \ )
794 # do
795 # IN="$ABCDETEMPDIR/track$1.$POSTPROCESSFORMAT"
796 # # We need IN to proceed.
797 # if [ -s "$IN" ] ; then
798 # #OUT="$ABCDETEMPDIR/track$1.$OUTPUT"
799 # run_command '' echo "Post-processing track $1 of $TRACKS..."
800 # case "$POSTPROCESSFORMAT" in
801 # mp3)
802 # run_command postprocess-$OUTPUT-$1 nice $POSTNICE $MP3_POST $IF $OF ;;
803 # ogg)
804 # run_command postprocess-$OUTPUT-$1 nice $POSTNICE $OGG_POST $IF $OF ;;
805 # flac)
806 # run_command postprocess-$OUTPUT-$1 nice $POSTNICE $FLAC_POST $IF $OF ;;
807 # spx)
808 # run_command postprocess-$OUTPUT-$1 nice $POSTNICE $SPX_POST $IF $OF ;;
809 # esac
810 # # Only remove .wav if the encoding succeeded
811 # if checkerrors "postprocess-(.{3,4})-$1"; then
812 # run_command postprocess-$1 false
813 # else
814 # run_command postprocess-$1 true
815 # fi
816 # else
817 # if [ "$(checkstatus encode-output)" = "loud" ]; then
818 # echo "HEH! The file we were about to post-process disappeared:"
819 # echo ">> $IN"
820 # fi
821 # run_command postprocess-$1 false
822 # fi
823 # done
824 #}
825
826 # do_batch_gain
827 # variables used:
828 # MP3GAIN, MP3GAINOPTS, VORBISGAIN, VORBISGAINOPTS
829 do_batch_gain ()
830 {
831 # The commands here don't go through run_command because they're never supposed to be silenced
832 echo "Batch analizing gain in tracks: $TRACKQUEUE"
833 (
834 cd "$ABCDETEMPDIR"
835 BLURB=
836 TRACKFILES=
837 for UTRACKNUM in $TRACKQUEUE
838 do
839 MP3FILES="$TRACKFILES track$UTRACKNUM.mp3"
840 done
841 # XXX: Hard-coded batch option!
842 $NORMALIZER -b $NORMALIZEROPTS $TRACKFILES
843 RETURN=$?
844 if [ "$RETURN" != "0" ]; then
845 echo "batch-normalize: $NORMALIZER returned code $RETURN" >> errors
846 else
847 for UTRACKNUM in $TRACKQUEUE
848 do
849 echo normalizetrack-$UTRACKNUM >> status
850 done
851 fi
852 )
853 }
854
855 # do_batch_normalize
856 # variables used:
857 # NORMALIZER, NORMALIZEROPTS
858 do_batch_normalize ()
859 {
860 # The commands here don't go through run_command because they're never supposed to be silenced
861 echo "Batch normalizing tracks: $TRACKQUEUE"
862 (
863 cd "$ABCDETEMPDIR"
864 BLURB=
865 TRACKFILES=
866 for UTRACKNUM in $TRACKQUEUE
867 do
868 TRACKFILES="$TRACKFILES track$UTRACKNUM.wav"
869 done
870 # XXX: Hard-coded batch option!
871 $NORMALIZER -b $NORMALIZEROPTS $TRACKFILES
872 RETURN=$?
873 if [ "$RETURN" != "0" ]; then
874 echo "batch-normalize: $NORMALIZER returned code $RETURN" >> errors
875 else
876 for UTRACKNUM in $TRACKQUEUE
877 do
878 echo normalizetrack-$UTRACKNUM >> status
879 done
880 fi
881 )
882 }
883
884 # do_normalize [tracknumber]
885 # variables used:
886 # TRACKS, TRACKNAME, NORMALIZER, NORMALIZEROPTS
887 do_normalize ()
888 {
889 IN="$ABCDETEMPDIR/track$1.wav"
890 if [ -e "$IN" ] ; then
891 run_command '' echo "Normalizing track $1 of $TRACKS: $TRACKNAME..."
892 run_command normalizetrack-$1 $NORMALIZER $NORMALIZEROPTS "$IN"
893 else
894 if [ "$(checkstatus encode-output)" = "loud" ]; then
895 echo "HEH! The file we were about to normalize disappeared:"
896 echo ">> $IN"
897 fi
898 run_command normalizetrack-$1 false "File $IN was not found"
899 fi
900 }
901
902 # do_move [tracknumber]
903 # Deduces the outfile from environment variables
904 # Creates directory if necessary
905 # variables used:
906 # TRACKNUM, TRACKNAME, TRACKARTIST, DALBUM, OUTPUTFORMAT, CDGENRE, CDYEAR
907 do_move ()
908 {
909 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
910 do
911 # Create ALBUMFILE, ARTISTFILE, TRACKFILE
912 # Munge filenames as follows:
913 # ' ' -> '_'
914 # '/' -> '_'
915 # ''' -> ''
916 # '?' -> ''
917 # Eat control characters
918 ALBUMFILE=$(mungefilename "$DALBUM")
919 ARTISTFILE=$(mungefilename "$TRACKARTIST")
920 TRACKFILE=$(mungefilename "$TRACKNAME")
921 GENRE=$(mungegenre "$GENRE")
922 YEAR=$(echo $CDYEAR)
923 # If we want to start the tracks with a given number, we need to modify the
924 # TRACKNUM value before evaluation
925 if [ -n "$STARTTRACKNUMBER" ] ; then
926 # Get the trackpadding from the current track
927 CURRENTTRACKPADDING=$(echo -n $UTRACKNUM | wc -c)
928 TRACKNUM=$( printf %0.${CURRENTTRACKPADDING}d $(expr ${UTRACKNUM} + ${STARTTRACKNUMBER} - $FIRSTTRACK ))
929 else
930 TRACKNUM=${UTRACKNUM}
931 fi
932 # Supported variables for OUTPUTFORMAT are GENRE, ALBUMFILE, ARTISTFILE,
933 # TRACKFILE, and TRACKNUM.
934 if [ "$VARIOUSARTISTS" = "y" ]; then
935 OUTPUTFILE=$(eval echo $VAOUTPUTFORMAT)
936 else
937 OUTPUTFILE=$(eval echo $OUTPUTFORMAT)
938 fi
939 # Check that the directory for OUTPUTFILE exists, if it doesn't, create it
940 OUTPUTFILEDIR=$(dirname "$OUTPUTDIR/$OUTPUTFILE")
941 # mkdir -p shouldn't return an error if the directory already exists
942 mkdir -p "$OUTPUTFILEDIR"
943 run_command movetrack-$1 mv "$ABCDETEMPDIR/track$1.$OUTPUT" "$OUTPUTDIR/$OUTPUTFILE.$OUTPUT"
944 done
945 }
946
947 # do_playlist
948 # Create the playlist if wanted
949 # Variables used:
950 # PLAYLISTFORMAT, PLAYLISTDATAPREFIX, VAPLAYLISTFORMAT, VAPLAYLISTDATAPREFIX,
951 # VARIOUSARTISTS, OUTPUTDIR
952 do_playlist ()
953 {
954 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
955 do
956 # Create a playlist file for the playlist data to go into.
957 # We used to wipe it out if it existed. Now we request permision if interactive.
958 for LASTTRACK in $TRACKQUEUE; do :; done
959 ALBUMFILE=$(mungefilename "$DALBUM")
960 ARTISTFILE=$(mungefilename "$DARTIST")
961 GENRE=$(mungegenre "$GENRE")
962 if [ "$VARIOUSARTISTS" = "y" ] ; then
963 PLAYLISTFILE=$(eval echo $VAPLAYLISTFORMAT)
964 else
965 PLAYLISTFILE=$(eval echo $PLAYLISTFORMAT)
966 fi
967 FINALPLAYLISTDIR=$(dirname "$OUTPUTDIR/$PLAYLISTFILE")
968 mkdir -p "$FINALPLAYLISTDIR"
969 if [ -s "$OUTPUTDIR/$PLAYLISTFILE" ]; then
970 echo -n "Erase, Append to, or Keep the existing playlist file? [e/a/k] (e): " >&2
971 if [ "$INTERACTIVE" = "y" ]; then
972 while [ "$DONE" != "y" ]; do
973 read ERASEPLAYLIST
974 case $ERASEPLAYLIST in
975 e|E|a|A|k|K) DONE=y ;;
976 *) ;;
977 esac
978 done
979 else
980 echo e >&2
981 ERASEPLAYLIST=e
982 fi
983 # Once we erase the playlist, we use append to create the new one.
984 [ "$ERASEPLAYLIST" = "e" -o "$ERASEPLAYLIST" = "E" ] && rm -f "$OUTPUTDIR/$PLAYLISTFILE" && ERASEPLAYLIST=a
985 else
986 # The playlist does not exist, so we can safelly use append to create the new list
987 ERASEPLAYLIST=a
988 fi
989 if [ "$ERASEPLAYLIST" = "a" -o "$ERASEPLAYLIST" = "A" ]; then
990 touch "$OUTPUTDIR/$PLAYLISTFILE"
991 for UTRACKNUM in $TRACKQUEUE
992 do
993 # Shares some code with do_move since the filenames have to match
994 CDDBTRACKNUM=$(expr $UTRACKNUM - 1)
995 TRACKNAME=$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | cut -f2 -d= | tr -d \[:cntrl:\] | sed 's/\ \+$//')
996 splitvarious
997 TRACKFILE=$(mungefilename "$TRACKNAME")
998 ARTISTFILE=$(mungefilename "$TRACKARTIST")
999 # If we want to start the tracks with a given number, we need to modify the
1000 # TRACKNUM value before evaluation
1001 if [ -n "$STARTTRACKNUMBER" ] ; then
1002 # Get the trackpadding from the current track
1003 CURRENTTRACKPADDING=$(echo -n $UTRACKNUM | wc -c)
1004 TRACKNUM=$( printf %0.${CURRENTTRACKPADDING}d $(expr ${UTRACKNUM} + ${STARTTRACKNUMBER} - $FIRSTTRACK ))
1005 else
1006 TRACKNUM=${UTRACKNUM}
1007 fi
1008 if [ "$VARIOUSARTISTS" = "y" ]; then
1009 OUTPUTFILE=$(eval echo $VAOUTPUTFORMAT)
1010 else
1011 OUTPUTFILE=$(eval echo $OUTPUTFORMAT)
1012 fi
1013 if [ "$VARIOUSARTISTS" = "y" ]; then
1014 if [ "$VAPLAYLISTDATAPREFIX" ] ; then
1015 echo ${VAPLAYLISTDATAPREFIX}$OUTPUTFILE.$OUTPUT >> "$OUTPUTDIR/$PLAYLISTFILE"
1016 else
1017 relpath "$PLAYLISTFILE", "$OUTPUTFILE.$OUTPUT" >> "$OUTPUTDIR/$PLAYLISTFILE"
1018 fi
1019 else
1020 if [ "$PLAYLISTDATAPREFIX" ]; then
1021 echo ${PLAYLISTDATAPREFIX}$OUTPUTFILE.$OUTPUT >> "$OUTPUTDIR/$PLAYLISTFILE"
1022 else
1023 relpath "$PLAYLISTFILE", "$OUTPUTFILE.$OUTPUT" >> "$OUTPUTDIR/$PLAYLISTFILE"
1024 fi
1025 fi
1026 done
1027 fi
1028 ## this will convert the playlist to have CRLF line-endings, if specified
1029 ## (some hardware players insist on CRLF endings)
1030 if [ "$DOSPLAYLIST" = "y" ]; then
1031 awk '{substr("\r",""); printf "%s\r\n", $0}' "$OUTPUTDIR/$PLAYLISTFILE" > "$ABCDETEMPDIR/PLAYLISTFILE.tmp"
1032 # mv -f "$ABCDETEMPDIR/PLAYLISTFILE.tmp" "$OUTPUTDIR/$PLAYLISTFILE"
1033 cat "$ABCDETEMPDIR/PLAYLISTFILE.tmp" | sed 's/\//\\/' > "$OUTPUTDIR/$PLAYLISTFILE"
1034 fi
1035 echo "playlistcomplete" >> "$ABCDETEMPDIR/status"
1036 done
1037 }
1038
1039 # do_discid
1040 # This essentially the start of things
1041 do_discid ()
1042 {
1043 # Query the CD to get the track info, unless the user specified -C
1044 # or we are using some actions which do not need the CDDB data at all
1045 #if [ ! X"$EXPACTIONS" = "X" ]; then
1046 # :
1047 #elif [ -z "$DISCID" ]; then
1048 if [ -z "$DISCID" ]; then
1049 vecho -n "Getting CD track info... "
1050 TRACKINFO=$($CDDISCID $CDROM)
1051 # Make sure there's a CD in there by checking cd-discid's return code
1052 if [ "$?" = "1" ]; then
1053 echo "abcde error: CD could not be read. Perhaps there's no CD in the drive?" >&2
1054 exit 1
1055 fi
1056 WEHAVEACD=y
1057 else
1058 TRACKINFO=$(cat "$WAVOUTPUTDIR/abcde.$DISCID/discid")
1059 fi
1060
1061 # Get a full enumeration of tracks, sort it, and put it in the TRACKQUEUE.
1062 # This needs to be done now because a section of the resuming code will need
1063 # it later.
1064
1065 # get the number of digits to pad TRACKNUM with - we'll use this later
1066 # a CD can only hold 99 tracks, but since we support a feature for starting
1067 # numbering the tracks from a given number, we might need to set it as a
1068 # variable for the user to define... or obtain it somehow.
1069 if [ "$PADTRACKS" = "y" ] ; then
1070 TRACKNUMPADDING=2
1071 fi
1072
1073 ABCDETEMPDIR="$WAVOUTPUTDIR/abcde.$(echo $TRACKINFO | cut -f1 -d' ')"
1074 if [ -z "$TRACKQUEUE" ]; then
1075 if [ ! "$STRIPDATATRACKS" = "y" ]; then
1076 case "$CDROMREADERSYNTAX" in
1077 cdparanoia|debug)
1078 if [ "$WEHAVEACD" = "y" ]; then
1079 vecho "Querying the CD for audio tracks..."
1080 CDPARANOIAOUTPUT="$( $CDROMREADER -d $CDROM -Q --verbose 2>&1 )"
1081 RET=$?
1082 if [ ! "$RET" = "0" ];then
1083 echo "Warning: Something went wrong while querying the CD... Maybe a DATA CD?"
1084 fi
1085 TRACKS="$( echo "$CDPARANOIAOUTPUT" | egrep '^[[:space:]]+[[:digit:]]' | tail -n 1 | get_first | tr -d "." | tr '\n' ' ' )"
1086 CDPARANOIAAUDIOTRACKS="$TRACKS"
1087 else
1088 if [ -f "$ABCDETEMPDIR/status" ] && checkstatus cdparanoia-audio-tracks ; then
1089 TRACKS=$( cat $ABCDETEMPDIR/cdparanoia-audio-tracks )
1090 else
1091 TRACKS=$(echo $TRACKINFO | cut -f2 -d' ')
1092 fi
1093 fi
1094 ;;
1095 *) TRACKS=$(echo $TRACKINFO | cut -f2 -d' ') ;;
1096 esac
1097 else
1098 TRACKS=$(echo $TRACKINFO | cut -f2 -d' ')
1099 fi
1100 if echo "$TRACKS" | grep "[[:digit:]]" > /dev/null 2>&1 ;then :;else
1101 echo "The disc does not contain any tracks. Giving up..."
1102 exit 0
1103 fi
1104 echo -n "Grabbing entire CD - tracks: "
1105 if [ ! "$PADTRACKS" = "y" ] ; then
1106 TRACKNUMPADDING=$(echo -n $TRACKS | wc -c | tr -d ' ')
1107 fi
1108 TRACKS=$(printf "%0.${TRACKNUMPADDING}d" $TRACKS)
1109 X=0
1110 while [ "$X" -ne "$TRACKS" ]
1111 do
1112 X=$(printf "%0.${TRACKNUMPADDING}d" $(expr $X + 1))
1113 TRACKQUEUE=$(echo "$TRACKQUEUE" $X)
1114 done
1115 echo $TRACKQUEUE
1116 else
1117 TRACKS=$(echo $TRACKINFO | cut -f2 -d' ')
1118 # User-supplied track queue.
1119 # Weed out non-numbers, whitespace, then sort and weed out duplicates
1120 TRACKQUEUE=$(echo $TRACKQUEUE | sed 's-[^0-9 ]--g' | tr ' ' '\n' | grep -v ^$ | sort -n | uniq | tr '\n' ' ' | sed 's- $--g')
1121 # Once cleaned, obtain the highest value in the trackqueue for number padding
1122 for LASTTRACK in $TRACKQUEUE; do :; done
1123 if [ ! "$PADTRACKS" = "y" ] ; then
1124 TRACKNUMPADDING=$(echo -n $LASTTRACK | wc -c | tr -d ' ')
1125 fi
1126 # Now we normalize the trackqueue
1127 for TRACK in $TRACKQUEUE ; do
1128 TRACKNUM=$(printf %0.${TRACKNUMPADDING}d $(expr ${TRACK} + 0 ))
1129 PADTRACKQUEUE=$(echo $PADTRACKQUEUE $TRACKNUM)
1130 done
1131 TRACKQUEUE=$PADTRACKQUEUE
1132 echo Grabbing tracks: "$TRACKQUEUE"
1133 fi
1134
1135 QUEUEDTRACKS=$(echo $TRACKQUEUE | wc -w | tr -d ' ')
1136
1137 # We have the discid, create a temp directory after it to store all the temp
1138 # info
1139
1140 if [ -e "$ABCDETEMPDIR" ]; then
1141 echo -n "abcde: attempting to resume from $ABCDETEMPDIR"
1142 # It already exists, see if it's a directory
1143 if [ ! -d "$ABCDETEMPDIR" ]; then
1144 # This is a file/socket/fifo/device/etc, not a directory
1145 # Complain and exit
1146 echo >&2
1147 echo "abcde: file $ABCDETEMPDIR already exists and does not belong to abcde." >&2
1148 echo "Please investigate, remove it, and rerun abcde." >&2
1149 exit 1
1150 fi
1151 echo -n .
1152 # It's a directory, let's see if it's owned by us
1153 if [ ! -O "$ABCDETEMPDIR" ]; then
1154 # Nope, complain and exit
1155 echo >&2
1156 echo "abcde: directory $ABCDETEMPDIR already exists and is not owned by you." >&2
1157 echo "Please investigate, remove it, and rerun abcde." >&2
1158 exit 1
1159 fi
1160 echo .
1161 # See if it's populated
1162 if [ ! -f "$ABCDETEMPDIR/discid" ]; then
1163 # Wipe and start fresh
1164 echo "abcde: $ABCDETEMPDIR/discid not found. Abcde must remove and recreate" >&2
1165 echo -n "this directory to continue. Continue? [y/n] (n)" >&2
1166 if [ "$INTERACTIVE" = "y" ]; then
1167 read ANSWER
1168 else
1169 echo y >&2
1170 ANSWER=y
1171 fi
1172 if [ "$ANSWER" != "y" ]; then
1173 exit 1
1174 fi
1175 rm -rf "$ABCDETEMPDIR" || exit 1
1176 mkdir "$ABCDETEMPDIR"
1177 if [ "$?" -gt "0" ]; then
1178 # Directory already exists or could not be created
1179 echo "abcde: Temp directory $ABCDETEMPDIR could not be created." >&2
1180 exit 1
1181 fi
1182 else
1183 # Everything is fine. Check for ^encodetracklocation-
1184 # and encode-output entries in the status file and
1185 # remove them. These are not relevant across sessions.
1186 if [ -f "$ABCDETEMPDIR/status" ]; then
1187 mv "$ABCDETEMPDIR/status" "$ABCDETEMPDIR/status.old"
1188 grep -v ^encodetracklocation- < "$ABCDETEMPDIR/status.old" \
1189 | grep -v ^encode-output > "$ABCDETEMPDIR/status"
1190 fi
1191 # Remove old error messages
1192 if [ -f "$ABCDETEMPDIR/errors" ]; then
1193 rm -f "$ABCDETEMPDIR/errors"
1194 fi
1195 fi
1196 else
1197 # We are starting from scratch
1198 mkdir "$ABCDETEMPDIR"
1199 if [ "$?" -gt "0" ]; then
1200 # Directory already exists or could not be created
1201 echo "abcde: Temp directory $ABCDETEMPDIR could not be created." >&2
1202 exit 1
1203 fi
1204 cat /dev/null > "$ABCDETEMPDIR/status"
1205 fi
1206 if [ X"$CUEFILE" = "Xy" -a X"$WEHAVEACD" = "Xy" ]; then
1207 if checkstatus cuefile ; then :; else
1208 $MKCUE $MKCUEOPTS > $ABCDETEMPDIR/cue-$(echo $TRACKINFO | cut -f1 -d' ').txt
1209 echo cuefile >> "$ABCDETEMPDIR/status"
1210 fi
1211 fi
1212 # If we got the CDPARANOIA status and it is not recorded, save it now
1213 if [ -n "$CDPARANOIAAUDIOTRACKS" ]; then
1214 if checkstatus cdparanoia-audio-tracks; then :; else
1215 if echo "$CDPARANOIAAUDIOTRACKS" >> "$ABCDETEMPDIR/cdparanoia-audio-tracks"; then
1216 echo "cdparanoia-audio-tracks" >> "$ABCDETEMPDIR/status"
1217 fi
1218 fi
1219 fi
1220
1221 # Create the discid file
1222 echo "$TRACKINFO" > "$ABCDETEMPDIR/discid"
1223 }
1224
1225 # do_cddbparse
1226 # Parses a CDDB file and outputs the title and the track names.
1227 # Variables: CDDBFILE
1228 do_cddbparse ()
1229 {
1230 CDDBPARSEFILE="$1"
1231 # List out disc title/author and contents
1232 if [ "$ONETRACK" = "y" ]; then
1233 vecho "ONETRACK mode selected: displaying only the title of the CD..."
1234 fi
1235 echo "---- $(grep DTITLE "${CDDBPARSEFILE}" | cut '-d=' -f2- | tr -d \\r\\n ) ----"
1236 if [ ! "$ONETRACK" = "y" ]; then
1237 for TRACK in $(f_seq_row 1 $TRACKS)
1238 do
1239 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "${CDDBPARSEFILE}" | cut -f2- -d= | tr -d \\r\\n)"
1240 done
1241 fi
1242 }
1243
1244 # do_localcddb
1245 # Check for a local CDDB file, and report success
1246 do_localcddb ()
1247 {
1248 if checkstatus cddb-readcomplete && checkstatus cddb-choice >/dev/null; then :; else
1249
1250 CDDBLOCALSUCCESS="n"
1251 CDDBDISCID=$(echo $TRACKINFO | cut -d' ' -f1)
1252 CDDBLOCALFILE="${CDDBLOCALDIR}/${CDDBDISCID}"
1253 USELOCALRESP="y"
1254
1255 # If the user has selected to check a local CDDB repo, we proceed with it
1256 if [ -r "${CDDBLOCALFILE}" ]; then
1257 # List out disc title/author and contents
1258 do_cddbparse "${CDDBLOCALFILE}"
1259 echo -n "Locally cached CDDB entry found, use it? [y/n] (y): "
1260 if [ "$INTERACTIVE" = "y" ]; then
1261 read USELOCALRESP
1262 while [ "$USELOCALRESP" != "y" ] && [ "$USELOCALRESP" != "n" ] && [ "$USELOCALRESP" != "" ] ; do
1263 echo -n 'Invalid selection. Please answer "y" or "n": '
1264 read USELOCALRESP
1265 done
1266 [ x"$USELOCALRESP" = "x" ] && USELOCALRESP="y"
1267 else
1268 echo "y" >&2
1269 fi
1270 if [ "$USELOCALRESP" = "y" ]; then
1271 #echo "Using local copy of CDDB data"
1272 cp "${CDDBLOCALFILE}" "$ABCDETEMPDIR/cddbread.1"
1273 echo 999 > "$ABCDETEMPDIR/cddbquery" # Assuming 999 isn't used by CDDB
1274 echo cddb-readcomplete >> "$ABCDETEMPDIR/status"
1275 do_cddbparse "${CDDBLOCALFILE}" > "$ABCDETEMPDIR/cddbchoices"
1276 echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
1277 CDDBLOCALSUCCESS="y"
1278 else
1279 #echo "Not using local copy of CDDB data"
1280 CDDBLOCALSUCCESS="n"
1281 fi
1282 else
1283 CDDBLOCALSUCCESS="n"
1284 fi
1285 fi
1286 }
1287
1288 # do_cddbstat
1289 do_cddbstat ()
1290 {
1291 # Perform CDDB protocol version check if it hasn't already been done
1292 if checkstatus cddb-statcomplete; then :; else
1293 if [ "$CDDBAVAIL" = "n" ]; then
1294 ERRORCODE=no_query
1295 echo 503 > "$ABCDETEMPDIR/cddbstat"
1296 else
1297 rc=1
1298 CDDBUSER=$(echo $HELLOINFO | cut -f1 -d'@')
1299 CDDBHOST=$(echo $HELLOINFO | cut -f2- -d'@')
1300 while test $rc -eq 1 -a $CDDBPROTO -ge 3; do
1301 vecho "Checking CDDB server status..."
1302 $CDDBTOOL stat $CDDBURL $CDDBUSER $CDDBHOST $CDDBPROTO > "$ABCDETEMPDIR/cddbstat"
1303 RESPONSECODE=$(head -n 1 "$ABCDETEMPDIR/cddbstat" | cut -f1 -d' ')
1304 case "$RESPONSECODE" in
1305 210) # 210 OK, status information follows (until terminating `.')
1306 rc=0;
1307 ;;
1308 501|*) # 501 Illegal CDDB protocol level: <n>.
1309 CDDBPROTO=`expr $CDDBPROTO - 1`
1310 ;;
1311 esac
1312 done
1313 if test $rc -eq 1; then
1314 CDDBAVAIL="n"
1315 fi
1316 fi
1317 echo cddb-statcomplete >> "$ABCDETEMPDIR/status"
1318 fi
1319 }
1320
1321
1322 # do_cddbquery
1323 do_cddbquery ()
1324 {
1325 CDDBDISCID=$(echo $TRACKINFO | cut -d' ' -f1)
1326 CDDBLOCALFILE="${CDDBLOCALDIR}/${CDDBDISCID}"
1327
1328 # Perform CDDB query if it hasn't already been done
1329 if checkstatus cddb-querycomplete; then :; else
1330 if [ "$CDDBAVAIL" = "n" ]; then
1331 ERRORCODE=no_query
1332 echo 503 > "$ABCDETEMPDIR/cddbquery"
1333 # The default CDDBLOCALSUCCESS is "n"
1334 # This part will be triggered if the user CDDB repo does not
1335 # contain the entry, or if we are not trying to use the repo.
1336 else
1337 vecho "Querying the CDDB server..."
1338 CDDBUSER=$(echo $HELLOINFO | cut -f1 -d'@')
1339 CDDBHOST=$(echo $HELLOINFO | cut -f2- -d'@')
1340 $CDDBTOOL query $CDDBURL $CDDBPROTO $CDDBUSER $CDDBHOST $TRACKINFO > "$ABCDETEMPDIR/cddbquery"
1341 ERRORCODE=$?
1342 case $ERRORCODE in
1343 0) # success
1344 ;;
1345 12|13|14)
1346 # no match found in database,
1347 # wget/fetch error, or user requested not to use CDDB
1348 # Make up an error code (503) that abcde
1349 # will recognize in do_cddbread
1350 # and compensate by making a template
1351 echo 503 > "$ABCDETEMPDIR/cddbquery"
1352 ;;
1353 *) # strange and unknown error
1354 echo ERRORCODE=$ERRORCODE
1355 echo "abcde: $CDDBTOOL returned unknown error code"
1356 ;;
1357 esac
1358 fi
1359 echo cddb-querycomplete >> "$ABCDETEMPDIR/status"
1360 fi
1361 }
1362
1363 # do_cddbread
1364 do_cddbread ()
1365 {
1366 # If it's not to be used, generate a template.
1367 # Then, display it (or them) and let the user choose/edit it
1368 if checkstatus cddb-readcomplete; then :; else
1369 vecho "Obtaining CDDB results..."
1370 # If CDDB is to be used, interpret the query results and read all
1371 # the available entries.
1372 rm -f "$ABCDETEMPDIR/cddbchoices"
1373 CDDBCHOICES=1 # Overridden by multiple matches
1374 RESPONSECODE=$(head -n 1 "$ABCDETEMPDIR/cddbquery" | cut -f1 -d' ')
1375 case "$RESPONSECODE" in
1376 200)
1377 # One exact match, retrieve it
1378 # 200 [section] [discid] [artist] / [title]
1379 if checkstatus cddb-read-1-complete; then :; else
1380 echo -n "Retrieving 1 CDDB match..." >> "$ABCDETEMPDIR/cddbchoices"
1381 $CDDBTOOL read $CDDBURL $CDDBPROTO $CDDBUSER $CDDBHOST $(cut -f2,3 -d' ' "$ABCDETEMPDIR/cddbquery") > "$ABCDETEMPDIR/cddbread.1"
1382 echo "done." >> "$ABCDETEMPDIR/cddbchoices"
1383 echo cddb-read-1-complete >> "$ABCDETEMPDIR/status"
1384 echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
1385 fi
1386 # List out disc title/author and contents
1387 echo ---- "$(cut '-d ' -f4- "$ABCDETEMPDIR/cddbquery")" ---- >> "$ABCDETEMPDIR/cddbchoices"
1388 for TRACK in $(f_seq_row 1 $TRACKS)
1389 do
1390 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "$ABCDETEMPDIR/cddbread.1" | cut -f2- -d= | tr -d \\r\\n)" >> "$ABCDETEMPDIR/cddbchoices"
1391 done
1392 echo >> "$ABCDETEMPDIR/cddbchoices"
1393 ;;
1394 202|403|409|503)
1395 # No match
1396 case "$RESPONSECODE" in
1397 202) echo "No CDDB match." >> "$ABCDETEMPDIR/cddbchoices" ;;
1398 403|409) echo "CDDB entry is corrupt, or the handshake failed." >> "$ABCDETEMPDIR/cddbchoices" ;;
1399 503) echo "CDDB unavailable." >> "$ABCDETEMPDIR/cddbchoices" ;;
1400 esac
1401 $CDDBTOOL template $(cat "$ABCDETEMPDIR/discid") > "$ABCDETEMPDIR/cddbread.0"
1402 # List out disc title/author and contents of template
1403 echo ---- Unknown Artist / Unknown Album ---- >> "$ABCDETEMPDIR/cddbchoices"
1404 UNKNOWNDISK=y
1405 for TRACK in $(f_seq_row 1 $TRACKS)
1406 do
1407 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "$ABCDETEMPDIR/cddbread.0" | cut -f2- -d= | tr -d \\r\\n)" >> "$ABCDETEMPDIR/cddbchoices"
1408 done
1409 echo >> "$ABCDETEMPDIR/cddbchoices"
1410 echo cddb-read-0-complete >> "$ABCDETEMPDIR/status"
1411 echo cddb-choice=0 >> "$ABCDETEMPDIR/status"
1412 ;;
1413 210|211)
1414 # Multiple exact, (possibly multiple) inexact matches
1415 IN=
1416 if [ "$RESPONSECODE" = "211" ]; then IN=in; fi
1417 if [ "$(wc -l < $ABCDETEMPDIR/cddbquery | tr -d ' ')" -eq 3 ]; then
1418 echo "One ${IN}exact match:" >> "$ABCDETEMPDIR/cddbchoices"
1419 tail -n +2 "$ABCDETEMPDIR/cddbquery" | head -n 1 >> "$ABCDETEMPDIR/cddbchoices"
1420 echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
1421 else
1422 echo "Multiple ${IN}exact matches:" >> "$ABCDETEMPDIR/cddbchoices"
1423 fi
1424 vecho -n "Retrieving multiple matches... "
1425 grep -v ^[.]$ "$ABCDETEMPDIR/cddbquery" | ( X=0
1426 read DISCINFO # eat top line
1427 while read DISCINFO
1428 do
1429 X=$(expr $X + 1)
1430 if checkstatus cddb-read-$X-complete; then :; else
1431 $CDDBTOOL read $CDDBURL $CDDBPROTO $CDDBUSER $CDDBHOST $(echo $DISCINFO | cut -f1,2 -d' ') > "$ABCDETEMPDIR/cddbread.$X"
1432 echo cddb-read-$X-complete >> "$ABCDETEMPDIR/status"
1433 fi
1434 # List out disc title/author and contents
1435 echo \#$X: ---- "$DISCINFO" ---- >> "$ABCDETEMPDIR/cddbchoices"
1436 for TRACK in $(f_seq_row 1 $TRACKS)
1437 do
1438 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "$ABCDETEMPDIR/cddbread.$X" | cut -f2- -d= | tr -d \\r\\n)" >> "$ABCDETEMPDIR/cddbchoices"
1439 done
1440 echo >> "$ABCDETEMPDIR/cddbchoices"
1441 done )
1442 vecho "done."
1443 CDDBCHOICES=$(expr $(cat "$ABCDETEMPDIR/cddbquery" | wc -l) - 2)
1444 ;;
1445 999)
1446 # Using local copy.
1447 for TRACK in $(f_seq_row 1 $TRACKS)
1448 do
1449 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "$ABCDETEMPDIR/cddbread.1" | cut -f2- -d= | tr -d \\r\\n)" >> "$ABCDETEMPDIR/cddbchoices"
1450 done
1451 echo >> "$ABCDETEMPDIR/cddbchoices"
1452 echo cddb-read-1-complete >> "$ABCDETEMPDIR/status"
1453 echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
1454 ;;
1455 esac
1456 echo "cddb-readcomplete" >> "$ABCDETEMPDIR/status"
1457 fi
1458 }
1459
1460 # do_cddbedit
1461 do_cddbedit ()
1462 {
1463 if checkstatus cddb-edit >/dev/null; then
1464 CDDBDATA="$ABCDETEMPDIR/cddbread.$(checkstatus cddb-choice)"
1465 VARIOUSARTISTS="$(checkstatus variousartists)"
1466 VARIOUSARTISTSTYLE="$(checkstatus variousartiststyle)"
1467 return 0
1468 fi
1469 if [ "$INTERACTIVE" = "y" ]; then
1470 # We should show the CDDB results both when we are not using the local CDDB repo
1471 # or when we are using it but we could not find a proper match
1472 if [ "$CDDBUSELOCAL" = "y" ] && [ ! "$CDDBLOCALSUCCESS" = "y" ] || [ ! "$CDDBUSELOCAL" = "y" ]; then
1473 # Display the $ABCDETEMPDIR/cddbchoices file created above
1474 # Pick a pager so that if the tracks overflow the screen the user can still view everything
1475 if [ -r "$ABCDETEMPDIR/cddbchoices" ]; then
1476 CDDBCHOICES=$(expr $(cat "$ABCDETEMPDIR/cddbquery" | wc -l) - 2)
1477 CHOICE=$(checkstatus cddb-choice)
1478 if [ -n "$CHOICE" ] ; then
1479 case $CDDBCHOICES in
1480 1) cat "$ABCDETEMPDIR/cddbchoices" ;;
1481 *)
1482 echo "Selected: #$CHOICE"
1483 do_cddbparse "$ABCDETEMPDIR/cddbread.$CHOICE"
1484 ;;
1485 esac
1486 else
1487 # The user has a choice to make, display the info in a pager if necessary
1488 if [ $(cat "$ABCDETEMPDIR/cddbchoices" | wc -l) -ge 24 ]; then
1489 # Use the debian sensible-pager wrapper to pick the pager
1490 # user has requested via their $PAGER environment variable
1491 if [ -x "/usr/bin/sensible-pager" ]; then
1492 /usr/bin/sensible-pager "$ABCDETEMPDIR/cddbchoices"
1493 elif [ -x "$PAGER" ]; then
1494 # That failed, try to load the preferred editor, starting
1495 # with their PAGER variable
1496 $PAGER "$ABCDETEMPDIR/cddbchoices"
1497 # If that fails, check for less
1498 elif [ -x /usr/bin/less ]; then
1499 /usr/bin/less -f "$ABCDETEMPDIR/cddbchoices"
1500 # more should be on all UNIX systems
1501 elif [ -x /bin/more ]; then
1502 /bin/more "$ABCDETEMPDIR/cddbchoices"
1503 else
1504 # No bananas, just cat the thing
1505 cat "$ABCDETEMPDIR/cddbchoices" >&2
1506 fi
1507 else
1508 # It's all going to fit in one page, cat it
1509 cat "$ABCDETEMPDIR/cddbchoices" >&2
1510 fi
1511
1512 # I'll take CDDB read #3 for $400, Alex
1513 echo -n "Which entry would you like abcde to use (0 for none)? [0-$CDDBCHOICES]: " >&2
1514 read CDDBCHOICE
1515 [ X"$CDDBCHOICE" = "X" ] && CDDBCHOICE=1
1516 # Make sure we get a valid choice
1517 CDCHOICENUM=$(echo $CDDBCHOICE | xargs printf %d 2>/dev/null)
1518 while [ $CDCHOICENUM -lt 0 ] || [ $CDCHOICENUM -gt $CDDBCHOICES ]; do
1519 echo "Invalid selection. Please choose a number between 1 and $CDDBCHOICES." >&2
1520 echo -n "Selection [0-$CDDBCHOICES]: " >&2
1521 read CDDBCHOICE
1522 CDCHOICENUM=$(echo $CDDBCHOICE | xargs printf %d 2>/dev/null)
1523 done
1524 if [ "$CDCHOICENUM" = "0" ]; then
1525 vecho "Creating empty CDDB template..."
1526 UNKNOWNDISK=y
1527 $CDDBTOOL template $(cat "$ABCDETEMPDIR/discid") > $ABCDETEMPDIR/cddbread.0
1528 else
1529 echo "Selected: #$CDCHOICENUM ($(grep ^DTITLE= $ABCDETEMPDIR/cddbread.$CDCHOICENUM | cut -f2- -d= | tr -d \\r\\n))" >&2
1530 do_cddbparse "$ABCDETEMPDIR/cddbread.$CDCHOICENUM"
1531 fi
1532 echo "cddb-choice=$CDCHOICENUM" >> "$ABCDETEMPDIR/status"
1533 fi
1534 fi
1535 else
1536 # We need some code to show the selected option when local repository is selected and we have found a match
1537 vecho "Using cached CDDB match..." >&2
1538 # Display the $ABCDETEMPDIR/cddbchoices file created above
1539 # Pick a pager so that if the tracks overflow the screen the user can still view everything
1540 if [ -r "$ABCDETEMPDIR/cddbchoices" ]; then
1541 CDDBCHOICES=$(expr $(cat "$ABCDETEMPDIR/cddbquery" | wc -l) - 2)
1542 CHOICE=$(checkstatus cddb-choice)
1543 if [ "$USELOCALRESP" = "y" ]; then :; else
1544 if [ -n "$CHOICE" ] ; then
1545 case $CDDBCHOICES in
1546 0)
1547 UNKNOWNDISK=y
1548 echo "Selected template."
1549 ;;
1550 1) cat "$ABCDETEMPDIR/cddbchoices" ;;
1551 *)
1552 echo "Selected: #$CHOICE"
1553 do_cddbparse "$ABCDETEMPDIR/cddbread.$CHOICE"
1554 ;;
1555 esac
1556 fi
1557 fi
1558 fi
1559 fi
1560 else
1561 # We're noninteractive - pick the first choice.
1562 # But in case we run a previous instance and selected a choice, use it.
1563 if [ -r "$ABCDETEMPDIR/cddbchoices" ]; then
1564 # Show the choice if we are not using the locally stored one
1565 # or when the local search failed to find a match.
1566 PREVIOUSCHOICE=$(checkstatus cddb-choice)
1567 if [ "$CDDBUSELOCAL" = "y" ] && [ "$CDDBLOCALSUCCESS" = "n" ] || [ ! "$CDDBUSELOCAL" = "y" ]; then
1568 #if [ "$PREVIOUSCHOICE" ]; then
1569 cat "$ABCDETEMPDIR/cddbchoices"
1570 #fi
1571 fi
1572 if [ ! -z "$PREVIOUSCHOICE" ] ; then
1573 CDCHOICENUM=$PREVIOUSCHOICE
1574 else
1575 CDCHOICENUM=1
1576 echo "cddb-choice=$CDCHOICENUM" >> "$ABCDETEMPDIR/status"
1577 fi
1578 echo "Selected: #$CDCHOICENUM ($(grep ^DTITLE= $ABCDETEMPDIR/cddbread.$CDCHOICENUM | cut -f2- -d= | tr -d \\r\\n))" >&2
1579 fi
1580 fi
1581
1582 # sanity check
1583 if checkstatus cddb-choice >/dev/null; then :; else
1584 echo "abcde: internal error: cddb-choice not recorded." >&2
1585 exit 1
1586 fi
1587 CDDBDATA="$ABCDETEMPDIR/cddbread.$(checkstatus cddb-choice)"
1588 echo -n "Edit selected CDDB data? [y/n] (" >&2
1589 if [ "$INTERACTIVE" = "y" ]; then
1590 if [ "$UNKNOWNDISK" = "y" ]; then
1591 echo -n "y): " >&2
1592 read EDITCDDB
1593 [ "$EDITCDDB" != "n" ] && EDITCDDB=y
1594 else
1595 echo -n "n): " >&2
1596 read EDITCDDB
1597 fi
1598 else
1599 echo "n): n" >&2
1600 EDITCDDB=n
1601 fi
1602 if [ "$EDITCDDB" = "y" ]; then
1603 CDDBDATAMD5SUM=$($MD5SUM "$CDDBDATA" | cut -d " " -f 1);
1604
1605 # Use the debian sensible-editor wrapper to pick the editor that the
1606 # user has requested via their $EDITOR environment variable
1607 if [ -x "/usr/bin/sensible-editor" ]; then
1608 /usr/bin/sensible-editor "$CDDBDATA"
1609 elif [ -n "$EDITOR" ]; then
1610 if [ -x $(which "${EDITOR%%\ *}") ]; then
1611 # That failed, try to load the preferred editor, starting
1612 # with their EDITOR variable
1613 eval $(echo "$EDITOR") "$CDDBDATA"
1614 fi
1615 # If that fails, check for a vi
1616 elif which vi >/dev/null 2>&1; then
1617 vi "$CDDBDATA"
1618 elif [ -x /usr/bin/vi ]; then
1619 /usr/bin/vi "$CDDBDATA"
1620 # nano should be on all (modern, i.e., sarge) debian systems
1621 elif which nano >/dev/null 2>&1 ; then
1622 nano "$CDDBDATA"
1623 elif [ -x /usr/bin/nano ]; then
1624 /usr/bin/nano "$CDDBDATA"
1625 # mg should be on all OpenBSD systems
1626 elif which mg >/dev/null 2>&1 ; then
1627 mg "$CDDBDATA"
1628 elif [ -x /usr/bin/mg ]; then
1629 /usr/bin/mg "$CDDBDATA"
1630 # bomb out
1631 else
1632 echo "No editor available. Check your EDITOR environment variable." >&2
1633 fi
1634 # delete editor backup file if it exists
1635 if [ -w "$CDDBDATA~" ]; then
1636 rm -f "$CDDBDATA~"
1637 fi
1638 fi
1639
1640 # Some heuristics first. Look at Disc Title, and if it starts with
1641 # "Various", then we'll assume Various Artists
1642 if [ "$(grep ^DTITLE= "$CDDBDATA" | cut -f2- -d= | egrep -ci '^(various|soundtrack|varios|sonora|ost)')" != "0" ]; then
1643 echo "Looks like a Multi-Artist CD" >&2
1644 VARIOUSARTISTS=y
1645 else
1646 echo -n "Is the CD multi-artist? [y/n] (n): " >&2
1647 if [ "$INTERACTIVE" = "y" ]; then
1648 read VARIOUSARTISTS
1649 else
1650 echo n >&2
1651 VARIOUSARTISTS=n
1652 fi
1653 fi
1654 if [ "$VARIOUSARTISTS" = "y" ] && [ ! "$ONETRACK" = "y" ]; then
1655 # Set a default
1656 DEFAULTSTYLE=1
1657 # Need NUMTRACKS before cddb-tool will return it:
1658 NUMTRACKS=$(egrep '^TTITLE[0-9]+=' "$CDDBDATA" | wc -l)
1659 if [ "$(grep -c "^TTITLE.*\/" "$CDDBDATA")" -gt "$(expr $NUMTRACKS / 2 )" ]; then
1660 # More than 1/2 tracks contain a "/", so guess forward
1661 DEFAULTSTYLE=1
1662 elif [ "$(grep -c "^TTITLE.*\-" "$CDDBDATA")" -gt "$(expr $NUMTRACKS / 2 )" ]; then
1663 # More than 1/2 contain a "-", so guess forward-dash
1664 DEFAULTSTYLE=2
1665 elif [ "$(grep -c "^TTITLE.*(.*)" "$CDDBDATA")" -gt "$(expr $NUMTRACKS / 2 )" ]; then
1666 # More than 1/2 contain something in parens, so guess trailing-paren
1667 DEFAULTSTYLE=6
1668 fi
1669
1670 echo "1) Artist / Title" >&2
1671 echo "2) Artist - Title" >&2
1672 echo "3) Title / Artist" >&2
1673 echo "4) Title - Artist" >&2
1674 echo "5) Artist: Title" >&2
1675 echo "6) Title (Artist)" >&2
1676 echo "7) This is a single-artist CD" >&2
1677 echo -n "Which style of multiple artist entries is it? [1-7] ($DEFAULTSTYLE): " >&2
1678 if [ "$INTERACTIVE" = "y" ]; then
1679 read VARIOUSARTISTSTYLE
1680 else
1681 echo $DEFAULTSTYLE >&2
1682 VARIOUSARTISTSTYLE=$DEFAULTSTYLE
1683 fi
1684 VARIOUSARTISTSTYLE=$(echo 0$VARIOUSARTISTSTYLE | xargs printf %d)
1685 # If they press Enter, then the default style (0) was chosen
1686 while [ $VARIOUSARTISTSTYLE -lt 0 ] || [ $VARIOUSARTISTSTYLE -gt 7 ]; do
1687 echo "Invalid selection. Please choose a number between 1 and 7."
1688 echo -n "Selection [1-7]: "
1689 read VARIOUSARTISTSTYLE
1690 VARIOUSARTISTSTYLE=$(echo 0$VARIOUSARTISTSTYLE | xargs printf %d)
1691 done
1692 if [ "$VARIOUSARTISTSTYLE" = "0" ]; then
1693 VARIOUSARTISTSTYLE=$DEFAULTSTYLE
1694 fi
1695 vecho "Selected: $VARIOUSARTISTSTYLE"
1696 case "$VARIOUSARTISTSTYLE" in
1697 1) # Artist / Title
1698 VARIOUSARTISTSTYLE=forward
1699 ;;
1700 2) # Artist - Title
1701 VARIOUSARTISTSTYLE=forward-dash
1702 ;;
1703 3) # Title / Artist
1704 VARIOUSARTISTSTYLE=reverse
1705 ;;
1706 4) # Title - Artist
1707 VARIOUSARTISTSTYLE=reverse-dash
1708 ;;
1709 5) # Artist: Title
1710 VARIOUSARTISTSTYLE=colon
1711 ;;
1712 6) # Title (Artist)
1713 VARIOUSARTISTSTYLE=trailing-paren
1714 ;;
1715 7) # Single Artist
1716 VARIOUSARTISTS=n
1717 ;;
1718 esac
1719 fi
1720
1721 echo "variousartists=$VARIOUSARTISTS" >> "$ABCDETEMPDIR/status"
1722 echo "variousartiststyle=$VARIOUSARTISTSTYLE" >> "$ABCDETEMPDIR/status"
1723
1724 if [ "$EDITCDDB" = "y" ] && [ "$UNINTENTIONALLY_ANGER_THE_FREEDB_PEOPLE" = "y" ]; then
1725 if [ $CDDBDATAMD5SUM != "" ] && [ $CDDBDATAMD5SUM != $($MD5SUM "$CDDBDATA" | cut -d " " -f 1) ]; then
1726 # This works but does not have the necessary error checking
1727 # yet. If you are familiar with the CDDB spec
1728 # (see http://www.freedb.org/src/latest/DBFORMAT)
1729 # and can create an error-free entry on your own, then put
1730 # UNINTENTIONALLY_ANGER_THE_FREEDB_PEOPLE=y in your
1731 # abcde.conf to enable it. Put CDDBSUBMIT=email@address in
1732 # your abcde.conf to change the email address submissions are
1733 # sent to.
1734
1735 # submit the modified file, if they want
1736 if [ "$NOSUBMIT" != "y" ]; then
1737 echo -n "Do you want to submit this entry to $CDDBSUBMIT? [y/n] (n): "
1738 read YESNO
1739 while [ "$YESNO" != "y" ] && [ "$YESNO" != "n" ] && [ "$YESNO" != "Y" ] && \
1740 [ "$YESNO" != "N" ] && [ "$YESNO" != "" ]
1741 do
1742 echo -n 'Invalid selection. Please answer "y" or "n": '
1743 read YESNO
1744 done
1745 if [ "$YESNO" = "y" ] || [ "$YESNO" = "Y" ]; then
1746 echo -n "Sending..."
1747 $CDDBTOOL send "$CDDBDATA" $CDDBSUBMIT
1748 echo "done."
1749 fi
1750 fi
1751 fi
1752 fi
1753 # Make sure the cache directory exists
1754 mkdir -p $CDDBLOCALDIR
1755 # Cache edited CDDB entry in the user's cddb dir
1756 if [ "$CDDBCOPYLOCAL" = "y" ] || [ "$COPYCDDBLOCAL" = "Y" ]; then
1757 cat "$CDDBDATA" | tail -n $(expr $(cat "$CDDBDATA" | wc -l ) - 1 ) > ${CDDBLOCALDIR}/$(echo "$TRACKINFO" | cut -d' ' -f1)
1758 fi
1759
1760 echo "cddb-edit" >> "$ABCDETEMPDIR/status"
1761 }
1762
1763 # do_cdread [tracknumber]
1764 # do_cdread onetrack [firsttrack] [lasttrack]
1765 #
1766 do_cdread ()
1767 {
1768 # The commands here don't go through run_command because they're never supposed to be silenced
1769 # return codes need to be doublechecked anyway, however
1770 if [ "$1" = "onetrack" ]; then
1771 # FIXME # Add the possibility of grabbing ranges of tracks in onetrack
1772 # FIXME # Until then, we grab the whole CD in one track, no matter what
1773 # the user said
1774 # We need the first and last track for cdda2wav
1775 FIRSTTRACK=$2
1776 LASTTRACK=$3
1777 case "$CDROMREADERSYNTAX" in
1778 cdparanoia) UTRACKNUM="$FIRSTTRACK-$LASTTRACK"
1779 cdda2wav) UTRACKNUM="$FIRSTTRACK+$LASTRACK" ;;
1780 *) echo "abcde error: $CDROMREADERSYNTAX does not support ONETRACK mode"
1781 exit 1 ;;
1782 esac
1783 else
1784 UTRACKNUM=$1
1785 fi
1786 CDDBTRACKNUM=$(expr $UTRACKNUM - 1)
1787 if [ "$USEPIPES" = "y" ]; then
1788 TEMPARG="PIPE_$CDROMREADERSYNTAX"
1789 FILEARG=${!TEMPARG}
1790 REDIR=""
1791 PIPE_MESSAGE="and encoding "
1792 else
1793 WAVDATA="$ABCDETEMPDIR/track$UTRACKNUM.wav"
1794 case "$CDROMREADERSYNTAX" in
1795 ## FIXME ## Find the case for dagrab, to avoid exceptions
1796 dagrab)
1797 FILEARG="-f $WAVDATA"
1798 ;;
1799 *)
1800 FILEARG=$WAVDATA
1801 ;;
1802 esac
1803 REDIR=">&2"
1804 fi
1805 if [ "$1" = "onetrack" ]; then
1806 echo "Grabbing ${PIPE_MESSAGE}tracks $UTRACKNUM..." >&2
1807 else
1808 if [ -r "$CDDBDATA" ]; then
1809 TRACKNAME=$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | head -n 1 | cut -f2 -d= | tr -d \[:cntrl:\])
1810 echo "Grabbing ${PIPE_MESSAGE}track $UTRACKNUM: $TRACKNAME..." >&2
1811 else
1812 echo "Grabbing ${PIPE_MESSAGE}track $UTRACKNUM..." >&2
1813 fi
1814 fi
1815 case "$CDROMREADERSYNTAX" in
1816 cdparanoia) nice $READNICE $CDROMREADER -d $CDROM $UTRACKNUM $FILEARG $REDIR ;;
1817 cdda2wav)
1818 if [ "$OSFLAVOUR" = "OSX" ] ; then
1819 # Hei, we have to unmount the device before running anything like cdda2wav in OSX
1820 disktool -u ${CDROM#/dev/} 0
1821 # Also, in OSX the cdrom device for cdda2wav changes...
1822 CDDA2WAVCDROM="IODVDServices"
1823 elif [ "$OSFLAVOUR" = "FBSD" ] ; then
1824 CDDA2WAVCDROM="$CDROMID"
1825 else
1826 if [ "$CDROMID" = "" ]; then
1827 CDDA2WAVCDROM="$CDROM"
1828 else
1829 CDDA2WAVCDROM="$CDROMID"
1830 fi
1831 fi
1832 nice $READNICE $CDROMREADER -D $CDDA2WAVCDROM -t $UTRACKNUM $FILEARG $REDIR
1833 ;;
1834 ## FIXME ## We have an exception for dagrab, since it uses -f
1835 ## FIXME ## Shall we just use -f $FILEARG ??
1836 dagrab) nice $READNICE $CDROMREADER -d $CDROM -v $UTRACKNUM $FILEARG $REDIR
1837 ;;
1838 cddafs)
1839 # Find the track's mounted path
1840 REALTRACKNUM=$(expr $UTRACKNUM + 0)
1841 FILEPATH=$(mount | grep "$CDROM on" | sed 's/^[^ ]* on \(.*\) (.*/\1/')
1842 FILEPATH=$(find "$FILEPATH" | grep "/$REALTRACKNUM ");
1843 # If the file exists, copy it
1844 if [ -e "$FILEPATH" ] ; then
1845 nice $READNICE $CDROMREADER "$FILEPATH" $FILEARG $REDIR
1846 else
1847 false
1848 fi ;;
1849 debug) nice $READNICE $CDROMREADER -d $CDROM -w $UTRACKNUM-[:1] $FILEARG $REDIR
1850 ;;
1851 esac
1852 RETURN=$?
1853 # If we get some error or we get some missing wav
1854 # (as long as we dont use pipes)
1855 if [ "$RETURN" != "0" -o \( ! -s "$WAVDATA" -a X"$USEPIPES" != "Xy" \) ]; then
1856 # Thank goodness errors is only machine-parseable up to the
1857 # first colon, otherwise this woulda sucked
1858 if [ "$RETURN" = "0" -a ! -s "$WAVDATA" ]; then
1859 RETURN=73 # fake a return code as cdparanoia return 0 also on aborted reads
1860 fi
1861 if [ "$USEPIPES" = "y" ]; then
1862 echo "readencodetrack-$UTRACKNUM: $CDROMREADER returned code $RETURN" >> "$ABCDETEMPDIR/errors"
1863 else
1864 echo "readtrack-$UTRACKNUM: $CDROMREADER returned code $RETURN" >> "$ABCDETEMPDIR/errors"
1865 fi
1866 return $RETURN
1867 else
1868 if [ "$USEPIPES" = "y" ]; then
1869 echo readencodetrack-$UTRACKNUM >> "$ABCDETEMPDIR/status"
1870 else
1871 echo readtrack-$UTRACKNUM >> "$ABCDETEMPDIR/status"
1872 fi
1873 fi
1874 }
1875
1876 # do_cdspeed
1877 # No values accepted, only uses env variables
1878 do_cdspeed ()
1879 {
1880 if "$CDSPEED" "$CDSPEEDOPTS" "$CDSPEEDVALUE" >/dev/null ; then
1881 vecho "Setting CD speed to ${CDSPEEDVALUE}x"
1882 else
1883 echo "abcde: unable to set the device speed" >&2
1884 fi
1885 }
1886
1887 # vecho [message]
1888 #
1889 # vecho outputs a message if EXTRAVERBOSE is selected
1890 vecho ()
1891 {
1892 if [ x"$EXTRAVERBOSE" != "x" ]; then
1893 echo $@
1894 fi
1895 }
1896
1897 # User-redefinable functions
1898 # Custom filename munging:
1899 mungefilename ()
1900 {
1901 #echo "$@" | sed s,:,\ -,g | tr \ /\* __+ | tr -d \'\"\?\[:cntrl:\]
1902 echo "$@" | sed s,:,\ -,g | tr \ / __ | tr -d \'\"\?\[:cntrl:\]
1903 }
1904
1905 # Custom genre munging:
1906 mungegenre ()
1907 {
1908 echo $CDGENRE | tr "[:upper:]" "[:lower:]"
1909 }
1910
1911 # pre_read
1912 # Empty pre_read function, to be defined in the configuration file.
1913 pre_read ()
1914 {
1915 :
1916 }
1917
1918 ###############################################################################
1919 # End of functions
1920 #
1921 # Start of execution
1922 ###############################################################################
1923
1924 # Builtin defaults
1925 CDDBURL="http://freedb.freedb.org/~cddb/cddb.cgi"
1926 CDDBSUBMIT=freedb-submit@freedb.org
1927 CDDBPROTO=5
1928 HELLOINFO="$(whoami)@$(hostname)"
1929 INTERACTIVE=y
1930 CDROMREADERSYNTAX=cdparanoia
1931 OUTPUTTYPE=ogg
1932 ENCODERSYNTAX=default
1933
1934 MP3ENCODERSYNTAX=default
1935 OGGENCODERSYNTAX=default
1936 FLACENCODERSYNTAX=default
1937 SPEEXENCODERSYNTAX=default
1938 MPPENCODERSYNTAX=default
1939 NORMALIZERSYNTAX=default
1940
1941 OUTPUTFORMAT='${ARTISTFILE}-${ALBUMFILE}/${TRACKNUM}.${TRACKFILE}'
1942 # Use the following VAOUTPUTFORMAT to revert to 2.0.x VA format:
1943 #VAOUTPUTFORMAT=${OUTPUTFORMAT}
1944 VAOUTPUTFORMAT='Various-${ALBUMFILE}/${TRACKNUM}.${ARTISTFILE}-${TRACKFILE}'
1945 ONETRACKOUTPUTFORMAT='${ARTISTFILE}-${ALBUMFILE}/${ALBUMFILE}'
1946 VAONETRACKOUTPUTFORMAT='Various-${ALBUMFILE}/${ALBUMFILE}'
1947 PLAYLISTFORMAT='${ARTISTFILE}-${ALBUMFILE}.${OUTPUT}.m3u'
1948 PLAYLISTDATAPREFIX=''
1949 VAPLAYLISTFORMAT='${ARTISTFILE}-${ALBUMFILE}.${OUTPUT}.m3u'
1950 VAPLAYLISTDATAPREFIX=''
1951 DOSPLAYLIST=n
1952 COMMENT=''
1953 ID3TAGV=2
1954 ENCNICE=10
1955 READNICE=10
1956 DISTMP3NICE=10
1957 VARIOUSARTISTS=n
1958 VARIOUSARTISTSTYLE=forward
1959 KEEPWAVS=n
1960 PADTRACKS=n
1961 CDDBCOPYLOCAL="n"
1962 CDDBLOCALDIR="$HOME/.cddb"
1963 CDDBUSELOCAL="n"
1964
1965 # If using scsi devices, cdda2wav needs a CDROMID, instead of a device node
1966 # i.e. CDROMID="1,0,0"
1967 CDROMID=""
1968
1969 # program paths - defaults to checking your $PATH
1970 # mp3
1971 LAME=lame
1972 GOGO=gogo
1973 BLADEENC=bladeenc
1974 L3ENC=l3enc
1975 XINGMP3ENC=xingmp3enc
1976 MP3ENC=mp3enc
1977 # ogg
1978 VORBIZE=vorbize
1979 OGGENC=oggenc
1980 # flac
1981 FLAC=flac
1982 # speex
1983 SPEEXENC=speexenc
1984 # mpp (Musepack)
1985 MPPENC=mppenc
1986
1987 ID3=id3
1988 ID3V2=id3v2
1989 CDPARANOIA=cdparanoia
1990 CDDA2WAV=cdda2wav
1991 DAGRAB=dagrab
1992 CDDAFS=cp
1993 CDDISCID=cd-discid
1994 CDDBTOOL=cddb-tool
1995 EJECT=eject
1996 MD5SUM=md5sum
1997 DISTMP3=distmp3
1998 VORBISCOMMENT=vorbiscomment
1999 METAFLAC=metaflac
2000 NORMALIZE=normalize-audio
2001 CDSPEED=eject
2002 VORBISGAIN=vorbisgain
2003 MKCUE=mkcue
2004
2005 # Options for programs called from abcde
2006 # mp3
2007 LAMEOPTS=
2008 GOGOOPTS=
2009 BLADEENCOPTS=
2010 L3ENCOPTS=
2011 XINGMP3ENCOPTS=
2012 MP3ENCOPTS=
2013 # ogg
2014 VORBIZEOPTS=
2015 OGGENCOPTS=
2016 # flac
2017 FLACOPTS=
2018 # speex
2019 SPEEXENCOPTS=
2020 # mpc
2021 MPPENCOPTS=
2022
2023 ID3OPTS=
2024 ID3V2OPTS=
2025 CDPARANOIAOPTS=
2026 CDDA2WAVOPTS=
2027 DAGRABOPTS=
2028 CDDAFSOPTS="-f"
2029 CDDBTOOLOPTS=
2030 EJECTOPTS=
2031 DISTMP3OPTS=
2032 NORMALIZEOPTS=
2033 CDSPEEDOPTS="-x"
2034 CDSPEEDVALUE=
2035 MKCUEOPTS=
2036 VORBISCOMMENTOPTS="-R"
2037 METAFLACOPTS="--no-utf8-convert"
2038
2039 # Default to one process if -j isn't specified
2040 MAXPROCS=1
2041
2042 # List of actions to perform - by default, run to completion
2043 ACTIONS=cddb,read,encode,tag,move,clean
2044
2045 # Asume fetch if under FreeBSD. curl is used for Mac OS X. wget is used for Linux/OpenBSD/NetBSD.
2046 # Let's use these checkings to determine the OS flavour, which will be used later
2047 if [ X$(uname) = "XFreeBSD" ] ; then
2048 HTTPGET=fetch
2049 NEEDCDROMID=y
2050 OSFLAVOUR=FBSD
2051 elif [ X$(uname) = "XDarwin" ] ; then
2052 HTTPGET=curl
2053 OSFLAVOUR=OSX
2054 # We should have disktool in OSX, but let's be sure...
2055 NEEDDISKTOOL=y
2056 elif [ X$(uname) = "XOpenBSD" ] ; then
2057 HTTPGET=wget
2058 MD5SUM=md5
2059 else
2060 HTTPGET=wget
2061 fi
2062
2063 # If CDDBAVAIL is set to n, no CDDB read is done
2064 # If USEID3 is set to n, no ID3 tagging is done
2065 CDDBAVAIL=y
2066 USEID3=y
2067 USEID3V2=y
2068
2069 if [ -z "$OUTPUTDIR" ]; then
2070 OUTPUTDIR=$(pwd)
2071 fi
2072
2073 if [ -z "$WAVOUTPUTDIR" ]; then
2074 WAVOUTPUTDIR="$OUTPUTDIR"
2075 fi
2076
2077 # Load system defaults
2078 if [ -r /etc/abcde.conf ]; then
2079 . /etc/abcde.conf
2080 fi
2081 # Load user preference defaults
2082 if [ -r $HOME/.abcde.conf ]; then
2083 . $HOME/.abcde.conf
2084 fi
2085
2086 # By this time, we need some HTTPGETOPTS already defined.
2087 # If the user has defined a non-default HTTPGET method, we should not be empty.
2088
2089 if [ "$HTTPGETOPTS" = "" ] ; then
2090 case $HTTPGET in
2091 wget) HTTPGETOPTS="-q -O -";;
2092 curl) HTTPGETOPTS="-f -s";;
2093 fetch)HTTPGETOPTS="-q -o -";;
2094 *) echo "abcde warning: HTTPGET in non-standard and HTTPGETOPTS are not defined." >&2 ;;
2095 esac
2096 fi
2097
2098 # If the CDROM has not been set yet, find a suitable one.
2099 # If this is a devfs system, default to /dev/cdroms/cdrom0
2100 # instead of /dev/cdrom
2101 if [ "$CDROM" = "" ] ; then
2102 if [ -e /dev/cdroms/cdrom0 ]; then
2103 CDROM=/dev/cdroms/cdrom0
2104 elif [ -e /dev/cdrom ]; then
2105 CDROM=/dev/cdrom
2106 elif [ -e /dev/cd0c ]; then
2107 CDROM=/dev/cd0c
2108 elif [ -e /dev/acd0c ]; then
2109 CDROM=/dev/acd0c
2110 elif [ -e /dev/disk1 ]; then
2111 CDROM=/dev/disk1
2112 fi
2113 fi
2114
2115 # Parse command line options
2116 #while getopts 1a:bc:C:d:Dhj:klLnNo:pr:S:t:T:vVx opt ; do
2117 while getopts 1a:A:bc:C:d:Dehj:klLmMnNo:pPr:Rs:S:t:T:vVxw:W: opt ; do
2118 case "$opt" in
2119 1) ONETRACK=y ;;
2120 a) ACTIONS="$OPTARG" ;;
2121 A) EXPACTIONS="$OPTARG";;
2122 b) BATCH=y ;;
2123 c) if [ -e "$OPTARG" ] ; then . "$OPTARG" ; else echo "abcde error: config file \"$OPTARG\" cannot be found." >&2 ; exit 1 ; fi ;;
2124 C) DISCID="${OPTARG#abcde.}" ;;
2125 d) CDROM="$OPTARG" ;;
2126 D) set -x ;;
2127 e) ERASEENCODEDSTATUS=y ;;
2128 h) usage; exit ;;
2129 e) ERASEENCODEDSTATUS=y ;;
2130 # f) FORCECDDBUSELOCAL=y ;;
2131 i) INLINETAG=y ;;
2132 j) MAXPROCS="$OPTARG" ;;
2133 k) KEEPWAVS=y ;;
2134 l) LOWDISK=y ;;
2135 L) CDDBUSELOCAL=y ;;
2136 n) CDDBAVAIL=n ;;
2137 N) INTERACTIVE=n ;;
2138 m) DOSPLAYLIST=y ;;
2139 M) CUEFILE=y ;;
2140 o) OUTPUTTYPE="$OPTARG" ;;
2141 p) PADTRACKS=y ;;
2142 P) USEPIPES=y ;;
2143 r) REMOTEHOSTS="$OPTARG" ;;
2144 R) REPLAYGAIN=y ;;
2145 s) STARTTRACKNUMBER="$OPTARG" ;;
2146 S) CDSPEEDVALUE="$OPTARG" ;;
2147 # t) PREPROCESSFORMATS="$OPTARG"
2148 # PREPROCESS=y ;;
2149 # T) POSTPROCESSFORMATS="$OPTARG" ;;
2150 t) STARTTRACKNUMBER="$OPTARG" ;;
2151 T) STARTTRACKNUMBER="$OPTARG" ; STARTTRACKNUMBERTAG="y" ;;
2152 v)
2153 echo "This is abcde v$VERSION."
2154 echo "Usage: abcde [options] [tracks]"
2155 echo "abcde -h for extra help"
2156 exit
2157 ;;
2158 V) EXTRAVERBOSE="y" ;;
2159 x) EJECTCD="y" ;;
2160 w) COMMENT="$OPTARG" ;;
2161 W) if echo $OPTARG | grep -q "[[:digit:]]" ; then
2162 STARTTRACKNUMBER="${OPTARG}01" ; STARTTRACKNUMBERTAG="y" ; COMMENT="CD${OPTARG}"
2163 else
2164 echo "abcde error: argument of -W must be integer"
2165 exit 1
2166 fi
2167 ;;
2168 ?) usage; exit ;;
2169 esac
2170 done
2171
2172 shift $(($OPTIND - 1))
2173
2174 # Decide if we can continue.
2175 if [ "$ONETRACK" = "y" ]; then
2176 # FIXME # remove check as soon as we find out about the other readers
2177 case "$CDROMREADERSYNTAX" in
2178 dagrab|cddafs|debug) echo "abcde error: ONETRACK reading is not suported with $CDROMREADERSYNTAX yet"
2179 exit 1 ;;
2180 esac
2181 if [ "$BATCH" = "y" ]; then
2182 echo "abcde error: BATCH mode is not compatible with ONETRACK mode"
2183 BATCH=n
2184 fi
2185 # It does not matter how many tracks we want. In ONETRACK mode we grab them all
2186 # FIXME # allow ranges of tracks to be selected for onetrack ripping
2187 if [ $# -gt 0 ]; then
2188 vecho "abcde warning: ONETRACK mode selected, grabbing all tracks..."
2189 fi
2190 else
2191 while [ $# -gt 0 ]; do
2192 # Range parsing code courtesy of Vincent Ho
2193 RSTART=$(echo $1 | cut -f1 -d-)
2194 REND=$(echo $1 | cut -f2 -d-)
2195 if [ "$RSTART" = "$REND" ]; then
2196 NEWTRACKS="$RSTART"
2197 else
2198 NEWTRACKS=$(f_seq_line $RSTART $REND)
2199 fi
2200 TRACKQUEUE=$(echo "$TRACKQUEUE" "$NEWTRACKS")
2201 shift
2202 done
2203 fi
2204
2205 # List of valid actions: cddb,read,normalize,encode,tag,move,playlist,clean
2206 # List of experimental actions: retag,transcode
2207
2208 # Determine what actions are to be done from $ACTIONS and set the
2209 # following environment variables for them:
2210 DOCDDB=n
2211 DOREAD=n
2212 DONORMALIZE=n
2213 DOPREPROCESS=n
2214 DOENCODE=n
2215 DOPOSTPROCESS=n
2216 DOTAG=n
2217 DOMOVE=n
2218 DOPLAYLIST=n
2219 DOCLEAN=n
2220
2221 for ACTION in $(echo $ACTIONS | tr , \ )
2222 do
2223 case $ACTION in
2224 cddb) DOCDDB=y;;
2225 read) DOREAD=y;;
2226 normalize) DONORMALIZE=y; DOREAD=y;;
2227 # preprocess) DOPREPROCESS=y; DOREAD=y;;
2228 encode) DOENCODE=y; DOREAD=y;;
2229 # postprocess) DOPREPROCESS=y; DOENCODE=y; DOREAD=y;;
2230 tag) DOTAG=y; DOREAD=y; DOENCODE=y; DOCDDB=y;;
2231 move) DOMOVE=y; DOTAG=y; DOREAD=y; DOENCODE=y; DOCDDB=y;;
2232 playlist) DOCDDB=y; DOPLAYLIST=y;;
2233 clean) DOCLEAN=y;;
2234 esac
2235 done
2236
2237 # Sanity checks:
2238
2239 # At this point a CDROM has to be defined, so we check it exists.
2240 if [ X"$CDROM" != "X" ] ; then
2241 if [ "$CDROMREADERSYNTAX" = "cdda2wav" ] && [ "$NEEDCDROMID" = "y" ] ; then
2242 if [ "$OSFLAVOUR" = "FBSD" ]; then
2243 if ! echo "$CDROMID" | grep "^[0-9],[0-9],[0-9]$" >/dev/null 2>&1 ; then
2244 echo "abcde error: CDROMID not in the right format for $CDROMREADERSYNTAX"
2245 echo "Use \"cdrecord -scanbus\" to obtain a adecuate ID an set CDROMID accordingly"
2246 exit 1
2247 fi
2248 elif [ ! -e "$CDROM" -a X"$DOREAD" = "Xy" ]; then
2249 echo "abcde error: CDROM device cannot be found." >&2
2250 exit 1
2251 fi
2252 # avoid processing if we are not going to hit the CDROM.
2253 elif [ X"$DOREAD" = "Xy" ]; then
2254 echo "abcde error: CDROM has not been defined or cannot be found" >&2
2255 exit 1
2256 fi
2257
2258 # USEPIPES pre-tests, before we get into more serious stuff
2259 # Not compatible with:
2260 # - multiple outputs
2261 # - normalize
2262 # - lowdisk algorithm
2263 # - anything else?
2264 if [ X"$USEPIPES" = "Xy" ]; then
2265 if [ $(echo $OUTPUTTYPE | tr , \ | wc -w ) -gt 1 ]; then
2266 echo "abcde error: Unix pipes not compatible with multiple outputs"
2267 exit 1
2268 fi
2269 if [ X"$DONORMALIZE" = "Xy" ]; then
2270 echo "abcde error: Unix pipes not compatible with normalizer"
2271 # FIXME # Do we need to exit or shall we just disable the mode?
2272 exit 1
2273 fi
2274 if [ X"$DOENCODE" = "Xn" ]; then
2275 vecho "Disabling Unix pipes since we are not encoding!"
2276 USEPIPES=n
2277 fi
2278 if [ X"$LOWDISK" = "Xy" ]; then
2279 vecho "abcde error: Unix pipes not compatible with lowdisk algorithm"
2280 exit 1
2281 fi
2282 fi
2283
2284 # Decide which CDROM reader we're gonna use
2285 case "$CDROMREADERSYNTAX" in
2286 cdparanoia|debug)
2287 CDROMREADER="$CDPARANOIA"
2288 CDROMREADEROPTS="$CDPARANOIAOPTS"
2289 ;;
2290 cdda2wav)
2291 CDROMREADER="$CDDA2WAV"
2292 CDROMREADEROPTS="$CDDA2WAVOPTS"
2293 ;;
2294 dagrab)
2295 CDROMREADER="$DAGRAB"
2296 CDROMREADEROPTS="$DAGRABOPTS"
2297 ;;
2298 cddafs)
2299 CDROMREADER="$CDDAFS"
2300 CDROMREADEROPTS="$CDDAFSOPTS"
2301 ;;
2302 esac
2303
2304 # There's only one normalize...
2305 case "$NORMALIZERSYNTAX" in
2306 default|normalize)
2307 NORMALIZER="$NORMALIZE"
2308 NORMALIZEROPTS="$NORMALIZEOPTS"
2309 ;;
2310 esac
2311
2312 # Allow -o OUTPUT(1):OPTIONS(1),...,OUTPUT(N):OPTIONS(N) mode of operation
2313 if echo $OUTPUTTYPE | grep ":" > /dev/null 2>&1 ; then
2314 OLDFS="$FS"
2315 export FS=","
2316 for OUTPUT in "$OUTPUTTYPE"
2317 do
2318 case "$OUTPUT" in
2319 ogg:*) OGGENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2320 mp3:*) MP3ENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2321 flac:*) FLACENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2322 spx:*) SPEEXENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2323 mpc:*) MPPENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2324 esac
2325 done
2326 for OUTPUT in "$OUTPUTTYPE"
2327 do
2328 TEMPOUTPUT=$( echo "$OUTPUT" | cut -d: -f1 )
2329 TEMPOUTPUTTYPE="${TEMPOUTPUTTYPE:+$TEMPOUTPUTTYPE,}$TEMPOUTPUT"
2330 done
2331 OUTPUTTYPE="$TEMPOUTPUTTYPE"
2332 FS="$OLDFS"
2333 fi
2334
2335 # If nothing has been specified, use oggenc for oggs and lame for mp3s and flac for flacs and speexenc for speex and mppenc for mpps
2336
2337 # Getting ready for multiple output changes
2338 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
2339 do
2340 case $OUTPUT in
2341 ogg) [ "$OGGENCODERSYNTAX" = "default" ] && OGGENCODERSYNTAX=oggenc
2342 [ "$DOTAG" = "y" ] && NEEDCOMMENTER=y
2343 [ "$REPLAYGAIN" = "y" ] && NEEDVORBISGAIN=y
2344 ;;
2345 mp3) [ "$MP3ENCODERSYNTAX" = "default" ] && MP3ENCODERSYNTAX=lame
2346 [ "$DOTAG" = "y" ] && NEEDTAGGER=y
2347 ;;
2348 flac) [ "$FLACENCODERSYNTAX" = "default" ] && FLACENCODERSYNTAX=flac
2349 [ "$DOTAG" = "y" ] && NEEDMETAFLAC=y
2350 ;;
2351 spx) [ "$SPEEXENCODERSYNTAX" = "default" ] && SPEEXENCODERSYNTAX=speexenc ;;
2352 mpc) [ "$MPPENCODERSYNTAX" = "default" ] && MPPENCODERSYNTAX=mppenc ;;
2353 *) echo "abcde error: Invalid OUTPUTTYPE defined" >&2
2354 exit 1
2355 ;;
2356 esac
2357 done
2358
2359 # decide which encoder
2360 case "$MP3ENCODERSYNTAX" in
2361 lame)
2362 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$LAMEOPTS}"
2363 MP3ENCODER="$LAME"
2364 ;;
2365 gogo)
2366 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$GOGOOPTS}"
2367 MP3ENCODER="$GOGO"
2368 ;;
2369 bladeenc)
2370 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$BLADEENCOPTS}"
2371 MP3ENCODER="$BLADEENC"
2372 ;;
2373 l3enc)
2374 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$L3ENCOPTS}"
2375 MP3ENCODER="$L3ENC"
2376 ;;
2377 xingmp3enc)
2378 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$XINGMP3ENCOPTS}"
2379 MP3ENCODER="$XINGMP3ENC"
2380 ;;
2381 mp3enc)
2382 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$MP3ENCOPTS}"
2383 MP3ENCODER="$MP3ENC"
2384 ;;
2385 esac
2386 case "$OGGENCODERSYNTAX" in
2387 vorbize)
2388 OGGENCODEROPTS="${OGGENCODEROPTSCLI:-$VORBIZEOPTS}"
2389 OGGENCODER="$VORBIZE"
2390 ;;
2391 oggenc)
2392 OGGENCODEROPTS="${OGGENCODEROPTSCLI:-$OGGENCOPTS}"
2393 OGGENCODER="$OGGENC"
2394 ;;
2395 esac
2396 case "$FLACENCODERSYNTAX" in
2397 flac)
2398 FLACENCODEROPTS="${FLACENCODEROPTSCLI:-$FLACOPTS}"
2399 FLACENCODER="$FLAC"
2400 ## FIXME ## FLAC streams can be encapsulated on a Ogg transport layer
2401 if echo "$FLACENCODEROPTS" | egrep -q -- "(^| )--ogg($| )" ;then
2402 FLACONOGG=y
2403 fi
2404 ;;
2405 esac
2406 case "$SPEEXENCODERSYNTAX" in
2407 speexenc)
2408 SPEEXENCODEROPTS="${SPEEXENCODEROPTSCLI:-$SPEEXENCOPTS}"
2409 SPEEXENCODER="$SPEEXENC"
2410 ;;
2411 esac
2412 case "$MPPENCODERSYNTAX" in
2413 mppenc)
2414 MPPENCODEROPTS="${MPPENCODEROPTSCLI:-$MPPENCOPTS}"
2415 MPPENCODER="$MPPENC"
2416 ;;
2417 esac
2418
2419 # and which tagger
2420
2421 if [ "$ID3TAGV" = "1" ]; then
2422 TAGGER="$ID3"
2423 TAGGEROPTS="$ID3OPTS"
2424 else
2425 TAGGER="$ID3V2"
2426 TAGGEROPTS="$ID3V2OPTS"
2427 fi
2428
2429 # Clean up nice options (either use '-n NICELEVEL or -NICELEVEL')
2430
2431 if [ "$ENCNICE" ]; then
2432 ENCNICE="-n $ENCNICE"
2433 fi
2434 if [ "$READNICE" ]; then
2435 READNICE="-n $READNICE"
2436 fi
2437 if [ "$DISTMP3NICE" ]; then
2438 DISTMP3NICE="-n $DISTMP3NICE"
2439 fi
2440
2441 # Don't check for stuff if it's not needed
2442 if [ "$REMOTEHOSTS" ]; then
2443 NEEDDISTMP3=y
2444 fi
2445 if [ "$DONORMALIZE" = "y" ]; then
2446 NEEDNORMALIZER=y
2447 fi
2448 if [ "$EJECTCD" = "y" ]; then
2449 NEEDEJECT=y
2450 fi
2451 if [ ! "$CDDBAVAIL" = "n" ] && [ "$DOCDDB" = "y" ]; then
2452 NEEDHTTPGET=y
2453 fi
2454 if [ "$CUEFILE" = "y" ]; then
2455 NEEDMKCUE=y
2456 fi
2457
2458 if [ X"$CDSPEEDVALUE" != "X" ]; then
2459 case "$CDROMREADERSYNTAX" in
2460 cdparanoia|debug) CDROMREADEROPTS="$CDPARANOIAOPTS -S $CDSPEEDVALUE" ;;
2461 *) NEEDCDSPEED=y ;;
2462 esac
2463 fi
2464
2465 # Rippers with USEPIPE support
2466 # FIXME # Include here all the rippers we can figure out support pipes
2467 PIPE_cdparanoia="-"
2468
2469 # Encoders with USEPIPE support
2470 # FIXME # Include here all the encoders we can figure out support pipes
2471 PIPE_lame="-"
2472 PIPE_bladeenc="-"
2473 PIPE_oggenc="-"
2474
2475 # Figure out if we can use pipes with the ripper/encoder combination
2476 # exit otherwise
2477 if [ "$USEPIPES" = "y" ]; then
2478 PIPERIPPERSVARCHECK="PIPE_${CDROMREADER}"
2479 case "$OUTPUT" in
2480 mp3)
2481 PIPEENCODERSVARCHECK="PIPE_$MP3ENCODERSYNTAX" ;;
2482 ogg)
2483 PIPEENCODERSVARCHECK="PIPE_$OGGENCODERSYNTAX" ;;
2484 flac)
2485 PIPEENCODERSVARCHECK="PIPE_$FLACENCODERSYTNAX" ;;
2486 spx)
2487 PIPEENCODERSVARCHECK="PIPE_$SPEEXENCODER" ;;
2488 mpc)
2489 PIPEENCODERSVARCHECK="PIPE_$MPPENCODER" ;;
2490 esac
2491 if [ ! -n "${!PIPERIPPERSVARCHECK}" ] ; then
2492 echo "abcde error: no support for pipes with given ripper" >&2
2493 echo "read the USEPIPES file from the source tarball to help" >&2
2494 echo "on a Debian system, read /usr/share/doc/abcde/USEPIPES.gz" >&2
2495 exit 1;
2496 fi
2497 if [ ! -n "${!PIPEENCODERSVARCHECK}" ] ; then
2498 echo "abcde error: no support for pipes with given encoder" >&2
2499 echo "read the USEPIPES file from the source tarball to help" >&2
2500 echo "on a Debian system, read /usr/share/doc/abcde/USEPIPES.gz" >&2
2501 exit 1;
2502 fi
2503 fi
2504
2505
2506 # Make sure a buncha things exist
2507 for X in $CDROMREADER $CDDISCID ${NEEDTAGGER+$TAGGER} $MP3ENCODER \
2508 $OGGENCODER $FLACENCODER $SPEEXENCODER $MPPENCODER \
2509 ${NEEDHTTPGET+$HTTPGET} ${NEEDDISTMP3+$DISTMP3} \
2510 ${NEEDCOMMENTER+$VORBISCOMMENT} ${NEEDMETAFLAC+$METAFLAC} \
2511 ${NEEDNORMALIZER+$NORMALIZER} ${NEEDEJECT+$EJECT} \
2512 ${NEEDDISKTOOL+disktool} ${NEEDCDSPEED+$CDSPEED} \
2513 ${NEEDVORBISGAIN+$VORBISGAIN} ${NEEDMKCUE+$MKCUE}
2514 do
2515 # Cut off the command-line options we just added in
2516 X=$(echo $X | cut -d' ' -f2)
2517 if [ "$(which $X)" = "" ]; then
2518 echo "abcde error: $X is not in your path." >&2
2519 exit 1
2520 elif [ ! -x $(which $X) ]; then
2521 echo "abcde error: $X is not executable." >&2
2522 exit 1
2523 fi
2524 done
2525
2526 CDROMREADER="$CDROMREADER $CDROMREADEROPTS"
2527 CDDBTOOL="$CDDBTOOL $CDDBTOOLOPTS"
2528 HTTPGET="$HTTPGET $HTTPGETOPTS"
2529
2530 # Here it used to say:
2531 # One thousand lines in, we can start doing stuff with things
2532 # Well, right now we are at line 2157 ;)
2533
2534 # Export needed things so they can be read in this subshell
2535 export CDDBTOOL ABCDETEMPDIR TRACKQUEUE LOWDISK EJECTCD EJECT EJECTOPTS
2536 export CDROM CDDBDATA REMOTEHOSTS MAXPROCS HTTPGET MD5SUM
2537
2538 # User-definable function to set some things. Use it for
2539 # - closing the CD tray with eject -t
2540 # - set the CD speed value with eject -x
2541 vecho -n "Executing customizable pre-read function... "
2542
2543 pre_read # Execute the user-defined pre-read funtion. Close the CD with it.
2544
2545 vecho "done."
2546
2547 do_discid # Get ABCDETEMPDIR created and status file initialized
2548
2549 if [ "$DOCDDB" = "y" ]; then
2550 if [ $CDDBUSELOCAL = "y" ]; then
2551 do_localcddb
2552 fi
2553 if checkstatus cddb-choice > /dev/null; then
2554 :
2555 else
2556 if [ ! "$CDDBLOCALSUCCESS" = "y" ] ; then
2557 do_cddbstat
2558 do_cddbquery
2559 do_cddbread
2560 fi
2561 fi
2562 do_cddbedit
2563
2564 eval $($CDDBTOOL parse "$CDDBDATA")
2565 fi
2566
2567 # Before reading tracks, we set the speed of the device
2568
2569 if [ X"$CDSPEEDVALUE" != "X" ]; then
2570 case "$CDROMREADERSYNTAX" in
2571 cdparanoia|debug) : ;;
2572 *) do_cdspeed ;;
2573 esac
2574 fi
2575
2576 # Define the first and last track, since we might need them later in several places
2577 FIRSTTRACK=$( get_first $TRACKQUEUE )
2578 LASTTRACK=$( get_last $TRACKQUEUE )
2579
2580 if [ -f "$ABCDETEMPDIR/status" ] && [ X"$ERASEENCODEDSTATUS" = "Xy" ]; then
2581 mv "$ABCDETEMPDIR/status" "$ABCDETEMPDIR/status.old"
2582 grep -v ^encodetracklocation- < "$ABCDETEMPDIR/status.old" \
2583 | grep -v ^encode-output > "$ABCDETEMPDIR/status"
2584 fi
2585
2586 # Create playlist if needed (backgroundable) and start reading in tracks
2587
2588 (
2589
2590 if [ ! "$ONETRACK" = "y" ]; then
2591 if [ "$DOPLAYLIST" = "y" ]; then
2592 echo Creating playlist... >&2
2593 do_playlist
2594 fi
2595 fi
2596
2597 # For the lowdisk option, only one program is running at once so the encoder
2598 # can be unsilenced right away.
2599 if [ "$LOWDISK" = "y" ] || [ "$ONETRACK" = "y" ]; then
2600 echo "encode-output=loud" >> "$ABCDETEMPDIR/status"
2601 fi
2602
2603 if [ "$ONETRACK" = "y" ]; then
2604 TRACKS="$FIRSTTRACK"
2605 if checkstatus readtrack-$FIRSTTRACK; then :; else
2606 do_cdread onetrack $FIRSTTRACK $LASTTRACK
2607 fi
2608 else
2609 for UTRACKNUM in $TRACKQUEUE
2610 do
2611 if [ "$DOREAD" = "y" ]; then
2612 if [ "$USEPIPES" = "y" ]; then
2613 if checkstatus readencodetrack-$UTRACKNUM; then :; else
2614 # Read, pipe, shut up!
2615 do_cdread $UTRACKNUM | do_encode $UTRACKNUM %local0% > /dev/null 2>&1
2616 fi
2617 else
2618 if checkstatus readtrack-$UTRACKNUM; then :; else
2619 do_cdread $UTRACKNUM
2620 fi
2621 if [ "$?" != "0" ]; then
2622 # CD read failed - don't give the goahead to
2623 # the encoder
2624 echo NO
2625 exit
2626 fi
2627 fi
2628 fi
2629 if [ "$BATCH" = "y" ]; then
2630 :
2631 else
2632 echo NEXTTRACK # Get the encoder machine churning again
2633 if [ "$DOREAD" = "y" ]; then
2634 if [ "$LOWDISK" = "y" ] && [ "$DOENCODE" = "y" ]; then
2635 until checkstatus encodetrack-$UTRACKNUM
2636 do
2637 if checkerrors encodetrack-$UTRACKNUM; then
2638 break
2639 fi
2640 sleep 2
2641 done
2642 fi
2643 fi
2644 fi
2645 done
2646 fi
2647
2648 # Now that we're done the encoding can be loud again -
2649 # if we're not using SMP.
2650 if [ "$MAXPROCS" = "1" ]; then
2651 echo "encode-output=loud" >> "$ABCDETEMPDIR/status"
2652 fi
2653
2654 # All tracks read, start encoding.
2655 if [ "$BATCH" = "y" ] || [ "$ONETRACK" = "y" ]; then
2656 echo NEXTTRACK
2657 fi
2658
2659 # We are now finished with the cdrom - it can be safely ejected. Note that
2660 # abcde will not have completed yet.
2661 if [ "$EJECTCD" = "y" ] && [ -x $(which $EJECT) ]; then
2662 # We check if the disk we are processing is actually the disk inside the
2663 # CD tray. If not, we do not eject the CD, since it might be so that the
2664 # user ejected it manually.
2665 #CURRENTTRACKINFO=$($CDDISCID $CDROM)
2666 #if if [ "$?" != "1" ] && [ "$CURRENTTRACKINFO" = "$TRACKINFO" ] ; then
2667 # More FreeBSD bits.
2668 if [ X"$(uname)" = X"FreeBSD" ] ; then
2669 # FreeBSD eject uses the EJECT environment variable to name the CDROM
2670 # but in this script EJECT is in the envionment and names the program
2671 eject=$EJECT
2672 unset EJECT
2673 # The FreeBSD eject needs "adc0" not "/dev/adc0c"
2674 cd="$(echo $CDROM | sed -e 's=.*/==;s=[a-h]$==;')"
2675 $eject $EJECTOPTS $cd
2676 elif [ X"$(uname)" = X"Darwin" ] ; then
2677 disktool -e ${CDROM#/dev/} 0
2678 else
2679 $EJECT $EJECTOPTS $CDROM
2680 fi
2681 #fi
2682 fi
2683
2684 ) | (
2685
2686 ## Do we need to pre-process
2687 #if [ x"$PREPROCESS" = "x" ] ; then
2688 # cat
2689 #else
2690 # for PRETRACKNUM in $TRACKQUEUE
2691 # do
2692 # read GOAHEAD
2693 # if [ "$GOAHEAD" = "NO" ]; then break; fi
2694 # PREPROCEED=
2695 # until [ $PREPROCEED ]
2696 # do
2697 # if checkstatus readtrack-$PRETRACKNUM; then PREPROCEED=y; break; fi
2698 # # all locations are working, wait and try again later
2699 # if [ ! $PREPROCEED ]; then sleep 3; fi
2700 # done
2701 # ( do_preprocess $PRETRACKNUM
2702 # echo "NEXTTRACK"
2703 # ) &
2704 # done
2705 #fi
2706 #
2707 #) | (
2708
2709 # In batch mode, we want all tracks to be read first.
2710 if [ "$BATCH" = "y" ]; then
2711 read GOAHEAD # For blocking - will contain either "NO" or "NEXTTRACK"
2712 if [ "$GOAHEAD" = "NO" ]; then break; fi
2713 for LASTTRACK in $TRACKQUEUE; do :; done
2714 if checkstatus readtrack-$LASTTRACK; then
2715 if [ "$DONORMALIZE" = "y" ]; then
2716 if checkstatus normalizetrack-$LASTTRACK; then :; else do_batch_normalize; fi
2717 if checkerrors batch-normalize; then exit; fi
2718 fi
2719 if [ "$DOENCODE" = "y" ]; then
2720 if checkstatus encodetrack-$LASTTRACK; then :; else do_batch_encode; fi
2721 if checkerrors batch-encode; then exit; fi
2722 fi
2723 fi
2724 fi
2725
2726 # If we are using ONETRACK, we can proceed with the normal encoding using just the $FIRSTTRACK as TRACKQUEUE
2727 if [ "$ONETRACK" = "y" ] ; then
2728 TRACKQUEUE="$FIRSTTRACK"
2729 TRACKS="$FIRSTTRACK"
2730 fi
2731
2732 # Do the encoding, including parallelization of remote encoding
2733 # Figure out where each track is going to be encoded
2734 ENCODELOCATIONS="$(echo $REMOTEHOSTS | tr , ' ')"
2735 if [ "$MAXPROCS" != "0" ]; then
2736 for NUM in $(f_seq_row 1 "$MAXPROCS")
2737 do
2738 ENCODELOCATIONS="$ENCODELOCATIONS %local$NUM%"
2739 done
2740 fi
2741 # Strip whitespace
2742 ENCODELOCATIONS=$(echo $ENCODELOCATIONS)
2743 for UTRACKNUM in $TRACKQUEUE
2744 do
2745 # Wait for our cue
2746 read GOAHEAD # For blocking - will contain either "NO" or "NEXTTRACK"
2747 if [ "$GOAHEAD" = "NO" ]; then break; fi
2748 # find out where this track is to be encoded
2749 if [ "$DOENCODE" = "y" -a "$USEPIPES" != "y" ]; then
2750 # Make sure we have a place to encode this, if not, exit stage right
2751 if [ -z "$ENCODELOCATIONS" ]; then
2752 continue
2753 fi
2754 PROCEED=
2755 until [ $PROCEED ]
2756 do
2757 for LOCATION in $ENCODELOCATIONS
2758 do
2759 PREVIOUSTRACK="$(checkstatus encodetracklocation-$LOCATION)"
2760 # check first if a track has ever been assigned to this location
2761 if [ -z "$PREVIOUSTRACK" ]; then PROCEED=y; break; fi
2762 # If it errored out, rebuild $ENCODELOCATIONS without this location in it
2763 if checkerrors encodetrack-$PREVIOUSTRACK; then
2764 for TEMPLOCATION in $ENCODELOCATIONS
2765 do
2766 if [ "$TEMPLOCATION" != "$LOCATION" ]; then
2767 TEMPENCODELOCATIONS="$TEMPENCODELOCATIONS $TEMPLOCATION"
2768 fi
2769 done
2770 ENCODELOCATIONS=$(echo $TEMPENCODELOCATIONS)
2771 ABORT=y
2772 PROCEED=y
2773 break
2774 fi
2775 # We're still here, this location must have been previously assigned,
2776 # and last completed without error - check if it's done with the
2777 # previous track yet
2778 if checkstatus encodetrack-$PREVIOUSTRACK; then PROCEED=y; break; fi
2779 done
2780 # all locations are working, wait and try again later
2781 if [ ! $PROCEED ]; then sleep 3; fi
2782 done
2783 # Record the location we're about to encode the next track at
2784 echo "encodetracklocation-$LOCATION=$UTRACKNUM" >> "$ABCDETEMPDIR/status"
2785 fi
2786 # Don't proceed with the rest of the loop if we can't encode
2787 if [ "$ABORT" ]; then continue; fi
2788 # Set TRACKNUM, TRACKNAME
2789 if [ -e "$CDDBDATA" ]; then
2790 if [ "$ONETRACK" = "y" ]; then
2791 TRACKNAME="$DALBUM"
2792 TRACKNUM="$FIRSTTRACK"
2793 splitvarious
2794 else
2795 # TRACKNUM=$(printf %0.${TRACKNUMPADDING}d $(expr ${UTRACKNUM} + 0))
2796 TRACKNUM=$UTRACKNUM
2797 CDDBTRACKNUM=$(expr $UTRACKNUM - 1)
2798 TRACKNAME="$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | cut -f2- -d= | tr -d \[:cntrl:\] | sed 's/\ \+$//')"
2799 splitvarious
2800 fi
2801 fi
2802 # You can't encode a file which needs to be normalized before finishing
2803 # You can't tag a file before it's finished encoding -
2804 # thus all of this is backgrounded together
2805 (
2806 if [ "$DONORMALIZE" = "y" ]; then
2807 if checkstatus readtrack-$UTRACKNUM; then
2808 if checkstatus normalizetrack-$UTRACKNUM; then :; else do_normalize $UTRACKNUM; fi
2809 fi
2810 fi
2811 if [ "$DOENCODE" = "y" -a "$USEPIPES" != "y" ]; then
2812 if checkstatus readtrack-$UTRACKNUM; then
2813 #if checkstatus encodetrack-$UTRACKNUM; then :; else do_encode $UTRACKNUM $LOCATION; fi
2814 if [ "$DONORMALIZE" = "y" ]; then
2815 if checkstatus normalizetrack-$UTRACKNUM; then
2816 if checkstatus encodetrack-$UTRACKNUM; then :; else do_encode $UTRACKNUM $LOCATION $OUTPUT; fi
2817 fi
2818 else
2819 if checkstatus encodetrack-$UTRACKNUM; then :; else do_encode $UTRACKNUM $LOCATION $OUTPUT; fi
2820 fi
2821 fi
2822 fi
2823 if [ "$DOTAG" = "y" ]; then
2824 if checkstatus encodetrack-$UTRACKNUM; then
2825 if checkstatus tagtrack-$UTRACKNUM; then :; else do_tag $UTRACKNUM; fi
2826 fi
2827 fi
2828 if [ "$DOMOVE" = "y" ]; then
2829 if checkstatus tagtrack-$UTRACKNUM; then
2830 if checkstatus movetrack-$UTRACKNUM; then :; else do_move $UTRACKNUM; fi
2831 fi
2832 fi
2833 ) &
2834 done
2835 # Go through it again and make sure there's no distmp3 stragglers, otherwise
2836 # we'll delete the files they're working on
2837 ## FIXME ## Check also for files which are encoded using PIPEs.
2838 if [ "$DOENCODE" = "y" -a "$USEPIPES" != "y" ]; then
2839 PROCEED=
2840 until [ $PROCEED ]
2841 do
2842 PROCEED=y
2843 for LOCATION in $ENCODELOCATIONS
2844 do
2845 CHECKTRACK="$(checkstatus encodetracklocation-$LOCATION)"
2846 # "How can he give us a status update, if he's DEAD?"
2847 if checkstatus encodetrack-$CHECKTRACK; then
2848 continue
2849 fi
2850 # Nothing to see here please go quietly back to your homes
2851 if [ -z "$CHECKTRACK" ]; then continue; fi
2852 # You're still here? Maybe there is something...
2853 if checkstatus encodetrack-$CHECKTRACK; then :; else PROCEED= ; break; fi
2854 done
2855 # hold up
2856 if [ ! $PROCEED ]; then sleep 5; fi
2857 done
2858 fi
2859 # If the above didn't catch the stragglers, this will
2860 wait
2861 # Check to see if run_command logged any errors
2862 if [ -f "$ABCDETEMPDIR/errors" ]; then
2863 echo "The following commands failed to run:"
2864 cat "$ABCDETEMPDIR/errors"
2865 # Don't clean up
2866 DOCLEAN=n
2867 fi
2868 if [ "$KEEPWAVS" = "y" ];then
2869 # Don't clean up
2870 DOCLEAN=n
2871 fi
2872 if [ "$DOCLEAN" = "y" ]; then
2873 # Wipe all the evidence
2874 # Gimme gimme gimme some more time!
2875 sleep 5
2876 rm -rf "$ABCDETEMPDIR"
2877 echo "Finished."
2878 else
2879 echo "Finished. Not cleaning $ABCDETEMPDIR."
2880 fi
2881 )
2882 exit 0
2883
2884 # b:is_bash
2885 # vim:tabstop=4